#!/usr/bin/perl
###########################################################################
#    WWWThreads  - Interactive Discussion Forum
#    Rick Baker scream@screamingweb.com 
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
###########################################################################
  use w3tvars qw(%config);
  use w3t qw($dbh);    
  use strict;


# ------------------
# Get the form input
# If we are allowing file attachments and we are dealing with a Mozilla 4.0
# browser then we get the input from the get_file sub, otherwise we just use
# the plain old get_input sub
  my %FORM;

  my $check = w3t::browser_check();

  if( ($check eq "true") && ($config{'files'}) ) {
    %FORM = w3t::get_file;
  }
  else {
    %FORM = w3t::get_input;
  }


# ------------------
# Check the referer
  w3t::db_connect();
  w3t::check_refer();


# ---------------------
# Assign the variables
  my $Subject  = $FORM{'Subject'};
  my $Body     = $FORM{'Body'};
  my $Board    = $FORM{'Board'};
  my $IP       = $FORM{'IP'};
  my $Parent   = $FORM{'Parent'};
  my $Main     = $FORM{'Main'};
  my $page     = $FORM{'page'};
  my $view     = $FORM{'view'};
  my $what     = $FORM{'what'};
  my $oldnumber = $FORM{'oldnumber'};
  my $mode     = $FORM{'mode'};
  my $sb       = $FORM{'sb'};
  my $mail     = $FORM{'mail'};
  my $PStatus  = $FORM{'PStatus'};

  my $query     = '';  
  my $sth       = '';  
  my $Signature = '';  
  my $rc        = 0;
  $mail ||=0;


  $Subject =~ s/%([0-9a-fA-F]{2})/pack("c",hex($1))/ge;
  $Body =~ s/%([0-9a-fA-F]{2})/pack("c",hex($1))/ge;

# ------------------------------------------------------
# Make sure the Username is either Anonymous or is valid.
  my %user;
  if ($FORM{'Username'} ne 'Anonymous') {
    if ($FORM{'Username'} and $FORM{'Password'}) {
      %user = w3t::authenticate($FORM{'Username'}, $FORM{'Password'});
    }
    else {
      %user = w3t::authenticate();
    }
  }
  if (($FORM{'Username'} ne 'Anonymous') and !(defined $user{'Username'}) ) {
    w3t::not_right("We could not find the Username/Password in our database.");
  }
  my ($Username,$Password);
  $user{'Username'} ? ($Username = $user{'Username'}) : ($Username = $FORM{'Username'});
  $user{'Password'} ? ($Password = $user{'Password'}) : ($Password = $FORM{'Password'});


# --------------------------
# Grab the board information
  my $Board_q = $dbh -> quote($Board);
  $query = qq!
    SELECT HTML,Anonymous,Locked,Markup
    FROM   Boards
    WHERE  Keyword = $Board_q
  !;
  $sth = $dbh -> prepare ($query) or die "Query syntax error: $DBI::errstr. Query: $query";
  $sth -> execute() or die "Can't execute query: $query. Reason: $DBI::errstr";
  my ($HTML,$Anonymous,$Locked,$Markup) = $sth -> fetchrow_array;


# -----------------------------------------------------------------------
# If Anonymous is off and they are trying to post as anonymous tell them
# it doesn't work
  if (($Anonymous eq "Off") && ($Username eq "Anonymous")) {
    $sth -> finish;
    w3t::not_right("Anonymous posts are not allowed on this board.");
  }


# ---------------------------------------------------------------
# If the board is locked and they are not an admin, let them know
  if(($Locked ne "Open") && ($user{'Status'} ne "Administrator") && ($user{'Status'} ne "Moderator") ) {
    $sth -> finish;
    w3t::not_right("This board is read only.  Only Administrators and Moderators can post here.");
  }


# --------------------------------------
# Lets see if this post is locked or not
  $PStatus = "O";
  if ($Parent) {
    my $query = qq!
      SELECT Status
      FROM $Board
      WHERE Number = $Parent
    !;
    $sth = $dbh -> prepare ($query) or die "Query syntax error: $DBI::errstr. Query: $query";
    $sth -> execute() or die "Can't execute query: $query. Reason: $DBI::errstr";
    ($PStatus) = $sth -> fetchrow_array;

  }

  if ( ($PStatus eq "C") && ($user{'Status'} ne "Administrator") && ($user{'Status'} ne "Moderator") ) {

    $sth -> finish;
    w3t::not_right("I'm sorry, this thread is locked and you don't have the proper permission to add to it.");

  }

# -------------------------------------
# Make sure the file size isn't too big
  if ($FORM{'FILE_CONTENT'}) {
    if (length($FORM{'FILE_CONTENT'}) > $config{'filesize'}) {
      $sth -> finish;
      w3t::not_right("The file you are trying to attach to your post exceeds the $config{'filesize'} byte limit.");
    }
  }

# -----------------------------------------------------------
# If username is anonymous then we set the mail variable to 0
  if ($Username eq "Anonymous") {
    $mail = 0;
  }


# ---------------------------------
# Get rid of < and > in the subject
  $Subject =~s /</&lt;/g;
  $Subject =~s />/&gt;/g;

# -------------------------------------------------------------
# If HTML is off then we need to get rid of < and > in the body
  if ($HTML eq "Off") {

    $Body =~s />/&gt;/g;
    $Body =~s /</&lt;/g;
    $Body =~s /&lt;br&gt;/<br>/g;

  }

# -----------------------------------------------------
# Let's find out if they get the default preview or not.
  my $Preview = $user{'Preview'};
  $Preview  ||= $config{'Preview'};

# -----------------------------------------------------------
# Add the signature to the post if we are not doing a preview
  if ($Preview eq "off") {
    $Body = "$Body<br><br>$user{'Signature'}"; 
  }

# -------------------------------------------
# If Markup is on the we format the markup code
  if ($Markup eq "On") {

    $Body =~ s/\[b\]/<b>/ig;
    $Body =~ s/\[\/b\]/<\/b>/ig;
    $Body =~ s/\[i\]/<i>/ig;
    $Body =~ s/\[\/i\]/<\/i>/ig;
                                 
  # -----------------------
  # Convert the color codes
    $Body =~ s/\[red\]/<font color=red>/ig;
    $Body =~ s/\[\/red\]/<\/font color=red>/ig;
    $Body =~ s/\[green\]/<font color=green>/ig;
    $Body =~ s/\[\/green\]/<\/font color=green>/ig;
    $Body =~ s/\[blue\]/<font color=blue>/ig;
    $Body =~ s/\[\/blue\]/<\/font color=blue>/ig;
    $Body =~ s/\[orange\]/<font color=orange>/ig;
    $Body =~ s/\[\/orange\]/<\/font color=orange>/ig;
    $Body =~ s/\[purple\]/<font color=purple>/ig;
    $Body =~ s/\[\/purple\]/<\/font color=purple>/ig;
    $Body =~ s/\[white\]/<font color=white>/ig;
    $Body =~ s/\[\/white\]/<\/font color=white>/ig;
    $Body =~ s/\[black\]/<font color=black>/ig;
    $Body =~ s/\[\/black\]/<\/font color=black>/ig;
    $Body =~ s/\[yellow\]/<font color=yellow>/ig;
    $Body =~ s/\[\/yellow\]/<\/font color=yellow>/ig;

  # --------------------
  # Convert the smiley's
    $Body =~s,\[smile\],<img src=\"$config{'images'}/smile.gif\">,isg;
    $Body =~s,\[frown\],<img src=\"$config{'images'}/frown.gif\">,isg;
    $Body =~s,\[wink\],<img src=\"$config{'images'}/wink.gif\">,isg;

  # ----------------------------
  # Replace quote markup -> html
    $Body =~ s,\[quote\](.*)\[/quote\],<blockquote><font size=1>In reply to:</fo
nt><hr><p>$1<p><hr></blockquote><p>,isg;

  # ---------------------------
  # Convert code markup -> html
    $Body =~ s,\[pre\](.*)\[/pre\],<pre>$1</pre><p>,isg;


  # ---------------------------
  # Convert url markup -> html
    $Body =~ s,\[url\]http://(.*)\[/url\],<A HREF="http://$1">http://$1</A>,isg;
    $Body =~ s,\[url\](.*)\[/url\],<A HREF="http://$1">http://$1</A>,isg;

  # ----------------------------
  # Convert email markup -> html
    $Body =~ s,\[email\](.*)\[/email\],<A HREF="mailto:$1">$1</A>,isg;



  # -------------------------------------------------
  # Convert image markup -> html if allowimages is on
    if ($config{'allowimages'}) {
      $Body =~ s,\[image\](.*)\[/image\],<IMG SRC="$1">,isg;
    }


  # ---------------------------------------------
  # Get rid of the trailing br's on certain codes
    $Body =~s/<\/blockquote><p><br>/<\/blockquote><p>/g;
    $Body =~s/<\/pre><p><br>/<\/pre><p>/g;
    $Body =~s/<pre><br>/<pre>/g;

  }


# -------------------------  
# Quote everything properly 
  $PStatus ||= "O";
  my $BodySig    = $Body;
  $BodySig       = $dbh -> quote($BodySig);
  my $Subject_q  = $dbh -> quote($Subject);
  my $Username_q = $dbh -> quote($Username);
  my $Kept_q     = $dbh -> quote("Off");
  my $PStatus_q  = $dbh -> quote($PStatus);

# ----------------------------------------------------------------
# Now we need to see if this post has already been made, basically
# protects from spamming
  $query = qq!
    SELECT Number
    FROM $Board
    WHERE Username = $Username_q AND Subject = $Subject_q AND Body = $BodySig
  !;
  $sth = $dbh->prepare ($query) or die "Can't prepare: $query. Reason: $DBI::errstr";
  $sth->execute ()              or die "Can't execute: $query. Reason: $DBI::errstr";
  my $rows = $sth -> rows;
  if ($rows) {
    $sth -> finish;
    w3t::not_right("This post has already been entered into the database.");
  } 



# --------------------
# Get the current time
  my $date = w3t::get_date;


# ------------------------------------------------------------------------
# As long as the User didn't post Anonymously we need to update some stuff
  my $Total = '';

  if ( $Username ne "Anonymous" ) {

    my %user = w3t::authenticate($Username, $Password);
    if (!(defined $user{'Username'})) {
      $sth -> finish; 
      w3t::not_right ("Strange, you must have edited the form manually and tried to change your login...");

    }
	
    my $Username_q = $dbh -> quote($Username);
    $query = qq!
    UPDATE Users
    SET    Totalposts = Totalposts + 1
    WHERE  Username = $Username_q
    !;

    $dbh->do($query) or die "Can't update posts: $query. Reason: $DBI::errstr";
  }



# -----------------------------------------------------
# If this isn't a reply post then $Parent gets set to 0
  if (!$Parent) { $Parent = 0; }
  

# ---------------------------------
# Insert the post into the database
  my $IP_q = $dbh -> quote($IP);

  if (!$Main) { $Main = 0; }

  $query = qq!
    INSERT INTO $Board (Parent,Main,Posted,Last_Post,Username,IP,Subject,Body,Mail,Kept,Status)
    VALUES ($Parent,$Main,$date,$date,$Username_q,$IP_q,$Subject_q,$BodySig,$mail,$Kept_q,$PStatus_q)
  !;
  $sth = $dbh->prepare ($query) or die "Can't prepare: $query. Reason: $DBI::errstr";
  $sth->execute ()              or die "Can't execute: $query. Reason: $DBI::errstr";



# -------------------------------------------------------------------
# Now we need to update the Last_Post on the first post of this thread
  $query = qq!
    UPDATE $Board
    SET Last_Post = $date
    WHERE Main = $Main
  !;
  $dbh ->do($query) or die "Can't execute query: $query. Reason: $DBI::errstr";


# -------------------------------------------------------------------------
# Get the last inserted record. NOTE: Mysql SPECIFIC FUNCTION! NOT PORTABLE!
  my $Mnumber = $sth->{'insertid'};


# --------------------------------------------------
# If we have a file attachment then we handle it here
  my $FileName;
  if ($FORM{'FILE_CONTENT'}) {

  # ------------------------------------------------
  # We need a little info to attach to the file name
    my $Board_q    = $dbh -> quote($Board);
    my $query = qq!
      SELECT Number
      FROM Boards
      WHERE Keyword = $Board_q
    !;
    $sth = $dbh->prepare ($query) or die "Can't prepare: $query. Reason: $DBI::errstr";
    $sth->execute ()              or die "Can't execute: $query. Reason: $DBI::errstr";
    my ($BoardN) = $sth->fetchrow_array;
  

    $FileName = $FORM{'FILE_NAME'};
    my $end;
    if ($FileName =~ /\//) {
      my @splitter = split(/\//,$FileName);
      my $parts = @splitter;
      $end = $splitter[$parts-1];
    }
    else {
      my @splitter = split(/\\/,$FileName);
      my $parts = @splitter;
      $end = $splitter[$parts-1];
    }
    $end =~s/"//g;
    $FileName = "$BoardN"."-$Mnumber"."-$end";

    if ($end) {
      open(FILE,">$config{'files'}/$FileName");
      print FILE "$FORM{'FILE_CONTENT'}";
      close(FILE);

    # ------------------------------------
    # Update the post to set the file name
      my $Filename_q = $dbh -> quote($FileName);
      my $query = qq!
        UPDATE $Board
        SET File = $Filename_q
        WHERE Number = $Mnumber
      !;
      $dbh -> do($query) or die "Can't execute quer: $query. Reason: $DBI::errstr.";

    }

  }


# -------------------------------------------------------
# IF main isn't set then we need to set main to the number
  if(!$Main) {
    $query = qq!
      UPDATE $Board
      SET Main = $Mnumber
      WHERE Number = $Mnumber
    !;
    $dbh -> do($query) or die "Can't execute quer: $query. Reason: $DBI::errstr.";
  }


# -----------------------------------------------------------
# If this is a reply then we need to check it's parent and see
# if it should be mailed to the starting post's owner
  $query = qq!
    SELECT Username,Subject,Mail
    FROM $Board
    WHERE Number = $Parent
  !;
  $sth = $dbh -> prepare($query) or die "Query syntax error: $DBI::errstr";
  $sth -> execute() or die "Can't exute query: $query. Reason: $DBI::errstr";

  my ($MailUser,$PostSubject,$Checkmail) = $sth -> fetchrow_array;


# -------------------------------------------------
# If Mail was set then we send an email to that user
  if ($Checkmail == 1) {

    my $MailUser_q = $dbh -> quote($MailUser);

    my $query = qq!
      SELECT Email
      FROM Users
      WHERE Username = $MailUser_q
    !;
    $sth = $dbh -> prepare($query) or die "Query syntax error: $DBI::errstr";
    $sth -> execute() or die "Can't execute query: $query. Reason: $DBI::errstr";
    my $rows = $sth -> rows;

  # -------------------------------------------
  # We need to make sure this user still exists
    if ($rows > 0){

      my ($Mailto) = $sth -> fetchrow_array;

      my $EmailBody = $Body;
      $EmailBody =~ s/<br>/\n/g;

      require Mailer;
      my $mailer = new Mailer ( { smtp => $config{'SMTP'}, sendmail => $config{'sendmail'} } ) or die "Can't init: $Mailer::error";
      my ($to) = $Mailto;
      my $from = $config{'emailaddy'};
      my $subject = "Reply to your post";
      my $msg     = "$Username replied to your post '$PostSubject' at the site: $config{'title'}.  The Url of this forum is $config{'cgiurl'}/wwwthreads.pl.  The reply was: \n\n$EmailBody";

      $mailer -> send( {to => $to, from => $from, subject => $subject, msg => $msg} ) or die "Can't mail message: $Mailer::error";

    }
   
  }



# ----------------------
# Update the total posts.
  $Board_q = $dbh -> quote($Board);
  $query = qq!
  UPDATE Boards 
  SET    Total = Total + 1,
  Last         = $date
  WHERE  Keyword = $Board_q
  !;
  $dbh -> do($query) or die "Can't execute quer: $query. Reason: $DBI::errstr.";


# ----------------------
# Mark this post as read
  my %cookie = w3t::get_cookie;
  my $bname = "$Board.read";
  my $read  = $cookie{$bname};
  my $adder = ",$Mnumber,";
  $read     = $read.$adder;
  w3t::set_cookie($bname,"$read",0);

# -----------------------------
# Figure out where to send them
  if($what eq "showpost") {

    w3t::send_header("Your post has been entered","<META HTTP-EQUIV=\"Refresh\" CONTENT=\"5;url=$config{'cgiurl'}/showpost.pl?Board=$Board&Number=$oldnumber&page=$page&view=$view&mode=$mode&sb=$sb\">");

  } else {

    w3t::send_header("Your post has been entered","<META HTTP-EQUIV=\"Refresh\" CONTENT=\"5;url=$config{'cgiurl'}/wwwthreads.pl?action=list&Board=$Board&page=$page&view=$view&sb=$sb\">");

  }


# ------------------------------------
# Now we give them a confirmation page
  w3t::table_header("Your post has been entered");;
  print qq~ 
  <p align=center>
  Your post has been entered.  Thanks for contributing to our forum.  You will be returned to the forum shortly.
  <br><br> 
  <a href="$config{'cgiurl'}/wwwthreads.pl?action=list&Board=$Board&page=$page&view=$view&sb=$sb">Return to the forum</a> | 
  <a href="$config{'cgiurl'}/showpost.pl?Board=$Board&Number=$Mnumber&page=$page&view=$view&mode=$mode&sb=$sb">View your Post</a></center>
  ~;


# ----------------
# Send the footer
  $sth -> finish;
  w3t::send_footer;

