#!/usr/bin/perl
###########################################################################
#    WWWThreads  - Interactive Discussion Forum
#    Rick Baker scream@screamingweb.com 
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
###########################################################################
  use w3tvars qw(%config);
  use w3t qw($dbh);
  use strict;


# ------------------------
# Connect to the database
  w3t::db_connect();


# ---------------------------
# Make sure this is an admin!
  my %user = w3t::authenticate();
  if ($user{'Status'} ne 'Administrator') {
    w3t::not_right ("You must be logged in, and be a valid administrator to access this.");
  }  


# ------------------------------------------
# Give them a form so they can create a board
  w3t::send_header("Create a board");
  w3t::table_header("Create a board");

  print qq~
    Fill in the following information to create a board.
    <br><br>
    <form method=POST action = "$config{'cgiurl'}/admin/docreate.pl">
    Board Title<br>
    <input type=text name = Title>
    <br><br>
    Keyword (Used for the name of the sql table - NO SPECIAL CHARACTERS)<br>
    <input type=text name = Keyword>
    <br><br>
    Description<br>
    <textarea name=Description cols=60 rows=5 wrap=soft></textarea>
    <br><br>
    Allow HTML<br>
    <input type=radio name=HTML value=On> Yes
    <input type=radio name=HTML value=Off> No
    <br><br>
    Allow Markup<br>
    <input type=radio name=Markup value=On> Yes
    <input type=radio name=Markup value=Off> No
    <br><br>
    Allow Anonymous Postings<br>
    <input type=radio name=Anonymous value=On> Yes 
    <input type=radio name=Anonymous value=Off> No
    <br><br>
    Allow public to post on this board<br>
    <input type=radio name=Locked value="Open"> Yes
    <input type=radio name=Locked value="Closed"> No
    <br><br>
    Expire threads after how many days (0 - Never Expire)<br>
    <input type=text name=Expires value=0 size=3>
    <br><br>
    Security Level (1-100 : Users with a lower secutiry level will not see this board)<br>
    <input type=text size=3 name=Security value=$config{'board_security'}>
    <br><br>
    Which category do you want to place this forum<br>
    <select name=Category>
    
    ~;
    my $query = qq!
      SELECT DISTINCT Title,Number FROM Category ORDER BY Title
    !;
    my $sth = $dbh -> prepare($query) or die "Can't prepare $query.  Reason: $DBI::errstr.";
    $sth -> execute() or die "Can't execute $query.  Reason: $DBI::errstr.";
    my $rows = $sth -> rows;
    for (my $i=0;$i<$rows;$i++) {
      my ($Cat,$Catnum) = $sth -> fetchrow_array;
      my $catname = "$Cat"."-PARSER-"."$Catnum";
      print "<option value=\"$catname\">$Cat";
    }
    $sth -> finish;
    print qq~
    </select>
    <br><br>
    <input type=submit value="Create Board">
    </form>
  ~;

# --------------
# Send the footer
  w3t::send_footer();
