#!/usr/bin/perl 
###########################################################################
#    WWWThreads  - Interactive Discussion Forum
#    Rick Baker scream@screamingweb.com 
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
###########################################################################
  use w3tvars qw(%config);
  use w3t qw($dbh);
  use strict;


# ----------------------
# Connect to the database
  w3t::db_connect();


# -------------
# Grab the input
  my %FORM = w3t::get_input();


# --------------------
# Assign the variables
  my $Username = $FORM{'Username'};
  my $Keyword  = $FORM{'Keyword'};
  my $Title    = $FORM{'Title'};


# --------------------------
# Make sure this is an admin!
  my %user = w3t::authenticate();
  if ($user{'Status'} ne 'Administrator') {
    w3t::not_right ("You must be logged in, and be a valid administrator to access this.");
  }


# --------------------------------------------------
# Update this user's status if they are not an admin
 
  my $newstat    = $dbh -> quote("Moderator");
  my $Username_q = $dbh -> quote($Username);
  my $Keyword_q  = $dbh -> quote($Keyword);
  my $checkstat  = $dbh -> quote("Administrator");

  my $query = qq!
    UPDATE Users 
    SET Status = $newstat
    WHERE Username = $Username_q AND Status <> $checkstat     
  !;
  $dbh -> do($query) or die "Can't execute query: $query. Reason: $DBI::errstr";

# ------------------------------------------
# Grab the previous moderator for this board
  $query = qq!
    SELECT Moderator
    FROM Boards
    WHERE Keyword = $Keyword_q
  !;
  my $sth = $dbh -> prepare ($query) or die "Query syntax error: $query. $DBI::errstr.";
  $sth -> execute() or die "Can't execute query: $query. Reason: $DBI::errstr.";

  my ($Oldmod) = $sth -> fetchrow_array;


# -----------------------------------------
# Now update the board to set the moderator
  my $query = qq!
    UPDATE Boards
    SET Moderator = $Username_q
    WHERE Keyword = $Keyword_q
  !;
  $dbh -> do($query) or die "Can't execute query: $query. Reason: $DBI::errstr";


# -----------------------------------------------------------------------
# Send the new moderator a message letting them know if it isn't the same
# as the old moderator
  if ($Username ne $Oldmod){

  # --------------------------------
  # Inform all admins and moderators 
    my $Sender  = $user{'Username'};
    my $To      = "A_M_GROUP";
    my $Subject = "A new moderator";
    my $mess    = "$Sender has given Moderator privileges to $Username for the board '$Title'";
    w3t::send_message($Sender,$To,$Subject,$mess);


    my $Sender  = $user{'Username'};
    my $To      = $Username;
    my $Subject = "New Moderator";
    my $mess    = "You have been assigned to be the moderator of the board '$Title'";
    w3t::send_message($Sender,$To,$Subject,$mess);    
  
  # ----------------------------------------
  # We also need to inform the old moderator
    my $Sender  = $user{'Username'};
    my $To      = $Oldmod;
    my $Subject = "Your moderator privileges";
    my $mess    = "You are no longer the moderator of the board '$Title'.  This has been assigned to another user.";
    w3t::send_message($Sender,$To,$Subject,$mess);


  }


# ------------------------
# Send them a confirmation
  w3t::send_header ("The moderator has been assigned.","<META HTTP-EQUIV=\"Refresh\" content=\"5;url=$config{'cgiurl'}/admin/login.pl\">");
  w3t::table_header("The moderator has been assigned.");

  print "$Username has been assigned to moderate the forum '$Title'.  You will now be returned to the main admin page.";

  $sth -> finish;
  w3t::send_footer();
