#!/usr/bin/perl 
###########################################################################
#    WWWThreads  - Interactive Discussion Forum
#    Rick Baker scream@screamingweb.com 
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
###########################################################################
  use w3tvars qw(%config);
  use w3t qw($dbh);
  use strict;


# -------------
# Get the input
  my %FORM = w3t::get_input();


# --------------------
# Assign the variables
  my $Banby  = $FORM{'Banby'};
  my $Who    = $FORM{'Who'};
  my $Reason = $FORM{'Reason'};


# ----------------------
# Connect to the database
  w3t::db_connect();


# --------------------------
# Make sure this is an admin!
  my %user = w3t::authenticate();
  if ( ($user{'Status'} ne 'Administrator') && ($user{'Status'} ne 'Moderator') ){
    w3t::not_right ("You must be logged in, and be a valid administrator or moderator to access this.");
  }


# -------------------------------------
# Let's see if they are already banned
  my $Selector   = '';
  my $Username_q = '';
  my $Hostname_q = '';
  my $Reason_q   = $dbh -> quote($Reason);
  my $Who_q      = $dbh -> quote($Who);

  if ($Banby eq "user") {
    $Selector = "Username";
    $Username_q = $Who_q;
    $Hostname_q = $dbh -> quote("NULL");
  }
  else {
    $Selector = "Hostname";
    $Username_q = $dbh -> quote("NULL");
    $Hostname_q = $Who_q;
  }

  my $query = qq!
    SELECT Reason
    FROM Banned
    WHERE $Selector = $Who_q
  !;
  my $sth = $dbh -> prepare($query) or die "Query syntax error: $query. Reason: $DBI::errstr.";
  $sth -> execute() or die "Can't execute query: $query. Reason: $DBI::errstr";
  my $rows = $sth -> rows;

  if ($rows > 0){

    my ($Reason) = $sth -> fetchrow_array;
    $sth -> finish;
    w3t::not_right("This $Selector has already been banned.  The reason was: $Reason");

  }


# ----------------------------------------------
# They weren't already banned, so let's ban them.
  my $query = qq!
    INSERT INTO Banned
    (Username,Hostname,Reason)
    VALUES ($Username_q,$Hostname_q,$Reason_q)
  !;

  $dbh -> do ($query) or die "Can't execute query: $query. Reason: $DBI::errstr.";


# ----------------------------------------------
# If we banned a user, lets send them a message.
  if ($Selector eq "Username") {

    my $Sender  = $user{'Username'};
    my $To      = $Who;
    my $Subject = "You have been banned.";
    my $mess    = "You have been banned from making any new posts or sending any private messages.  The reason for this ban was: $Reason";

    w3t::send_message($Sender,$To,$Subject,$mess);

  }


# ---------------------------
# Lets inform the admin group
  my $Sender  = $user{'Username'};
  my $To      = "ADMIN_GROUP";
  my $Subject = "Banned $Selector";
  my $mess    = "$Sender has banned the $Selector '$Who'.  The Reason for this ban was: $Reason";

  w3t::send_message($Sender,$To,$Subject,$mess);


# ------------------------
# Send them a page 
  w3t::send_header ("$Selector banned","<META HTTP-EQUIV=\"Refresh\" content=\"5;url=$config{'cgiurl'}/admin/login.pl\">");
  w3t::table_header("$Selector has been banned.");

  print "The $Selector '$Who' has been banned.  You will now be returned to the main administration page.";

  $sth -> finish;
  w3t::send_footer();
