#!/usr/bin/perl 
###########################################################################
#    WWWThreads  - Interactive Discussion Forum
#    Rick Baker scream@screamingweb.com 
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
###########################################################################
  use w3tvars qw(%config);
  use w3t qw($dbh);
  use strict;


# ----------------------
# Connect to the database
  w3t::db_connect();


# -------------
# Grab the input
  my %FORM = w3t::get_input();


# -------------------
# Assign the variable
  my $Title = $FORM{'Title'};


# --------------------------
# Make sure this is an admin!
  my %user = w3t::authenticate();
  if ($user{'Status'} ne 'Administrator') {
    w3t::not_right ("You must be logged in, and be a valid administrator to access this.");
  }


# -----------------------------------------------
# Grab the current boards
  my $Title_q = $dbh -> quote($Title);
  my $NULL_q  = $dbh -> quote("NULL");
  my $query = qq!
    SELECT Title,Keyword,Sorter
    FROM Category
    WHERE Title = $Title_q 
    AND Keyword <> $NULL_q
    ORDER BY Sorter
  !;
  my $sth = $dbh -> prepare($query) or die "Query syntax error: $query. $DBI::errstr";
  $sth -> execute() or die "Can't execute query: $query. Reason: $DBI::errstr";

  my $rows = $sth -> rows;

  
# ------------------------------------------------------------------------
# Now we change the sort order but we need to do some error checking along
# the way.
  my $assigned = '';
  for (my $i=0; $i < $rows ; $i++){

    my ($Title,$Keyword,$Sorter) = $sth -> fetchrow_array;
    if ($FORM{$Keyword} < 1) {
       
      w3t::not_right("The lowest number you can assign to any board is 1.");

    }
    if ($FORM{$Keyword} =~/\./) {
      
      w3t::not_right("Umm, how about entering a whole number.");

    }
    if ($FORM{$Keyword} > $rows) {

      w3t::not_right("The highest number you can assign to any board is $rows.");

    }
    
    my $check = ",$FORM{$Keyword},";
    if ($assigned =~/$check/) {

      w3t::not_right("You cannot assign the same number to more than 1 board.");

    }
    $assigned = $assigned.",$check,";

    my $Number    = $FORM{$Keyword};
    my $Keyword_q = $dbh -> quote($Keyword);

    my $query = qq!
      UPDATE Category SET Sorter=$Number
      WHERE Keyword = $Keyword_q
    !;

    $dbh -> do($query) or die "Can't execute query: $query. Reason: $DBI::errstr.";

  }

# ------------------------
# Send them a confirmation
  w3t::send_header ("Forum order has been changed.","<META HTTP-EQUIV=\"Refresh\" content=\"5;url=$config{'cgiurl'}/admin/login.pl\">");
  w3t::table_header("Forum order has been changed.");

  print "The Forum order has been changed in the database.  You will now be returned to the main admin page.";

  $sth -> finish;
  w3t::send_footer();
