#!/usr/bin/perl 
###########################################################################
#    WWWThreads  - Interactive Discussion Forum
#    Rick Baker scream@screamingweb.com 
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
###########################################################################
  use w3tvars qw(%config);
  use w3t qw($dbh);
  use strict;


# ----------------------
# Connect to the database
  w3t::db_connect();


# --------------------------
# Make sure this is an admin!
  my %user = w3t::authenticate();
  if ($user{'Status'} ne 'Administrator') {
    w3t::not_right ("You must be logged in, and be a valid administrator to access this.");
  }


# -------------
# Get the input
  my %FORM = w3t::get_input();


# --------------------
# Assign the variables
  my $Title       = $FORM{'Title'};


# ---------------------------------------------
# Check to make sure all info has been filled in
  if(!$Title){
    w3t::not_right("All of the required informatin has not been filled in.  Please try again.");
  }


# --------------------------------------------
# Make sure the category doesn't already exist
  my $Title_q = $dbh -> quote($Title);
  my $query = qq!
    SELECT Title
    FROM Category
    WHERE Title = $Title_q
  !;
  my $sth = $dbh -> prepare($query) or die "Can't prepare $query.  Reason: $DBI::errstr.";
  $sth ->execute() or die "Can't execute $query.  Reason: $DBI::errstr.";
  my $check = $sth -> rows;
  if ($check) {
    w3t::not_right("That Category already exists.");
  }


# -------------------------------
# Put the category into the database
  my $query = qq!
    SELECT Distinct Number FROM Category ORDER By Number DESC
  !;
  my $sth = $dbh -> prepare($query) or die "Can't prepare $query.  Reason: $DBI::errstr.";
  $sth -> execute() or die "Can't execute $query.  Reason: $DBI::errstr.";
  my ($Number) = $sth -> fetchrow_array;
  $Number++;
 
  my $Title_q       = $dbh -> quote($Title);

  my $query = qq!
    INSERT INTO Category (Title,Number)
    VALUES ($Title_q,$Number)
  !;
  $dbh->do ($query) or w3t::not_right("That category is already being used.  Please try again.");


# ------------------------
# Send them a confirmation
  w3t::send_header ("The new category has been created.","<META HTTP-EQUIV=\"Refresh\" content=\"5;url=$config{'cgiurl'}/admin/login.pl\">");
  w3t::table_header("The new category has been created.");

  print " The new category has been created and is now available for forums to be placed within it.  </P>";
  w3t::send_footer();
