#!/usr/bin/perl
###########################################################################
#    WWWThreads  - Interactive Discussion Forum
#    Rick Baker scream@screamingweb.com 
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
###########################################################################
  use w3tvars qw(%config);
  use w3t qw($dbh);
  use strict;


# ----------------------
# Connect to the database
  w3t::db_connect();


# -------------
# Grab the input
  my %FORM = w3t::get_input();


# --------------------
# Assign the variables
  my $User      = $FORM{'User'};


# --------------------------
# Make sure this is an admin
  my %user = w3t::authenticate();
  if ($user{'Status'} ne 'Administrator') {

    w3t::not_right ("You must be logged in, and be a valid administrator access this.");

  }


# --------------------------------------
# Delete the user from the users table 
  my $User_q      = $dbh -> quote($User);

  my $query = qq!
    DELETE FROM Users 
    WHERE Username = $User_q 
  !;
  $dbh -> do($query) or die "Can't execute query: $query.  Reason: $DBI::errstr";


# ----------------------------------------
# Delete all entries in the Subscribe table
  $query = qq!
    DELETE FROM Subscribe 
    WHERE Username = $User_q 
  !;
  $dbh -> do($query) or die "Can't execute query: $query.  Reason: $DBI::errstr";


# ----------------------------------------------
# Delete any private messages for this user
  $query = qq!
    DELETE FROM Messages
    WHERE Username = $User_q 
  !;
  $dbh -> do($query) or die "Can't execute query: $query.  Reason: $DBI::errstr";

# ----------------------------------------------------------------------
# Grab all the boards so we can get rid of the entries for this board in
# the individual board last viewed table
  $query = qq!
    SELECT Keyword
    FROM Boards
  !;
  my $sth = $dbh -> prepare($query) or die "Can't prepare $query.  Reason: $DBI::errstr.";
  $sth -> execute() or die "Can't prepare $query.  Reason: $DBI::errstr.";
 
  my $rows = $sth -> rows;
  for (my $i=0; $i < $rows; $i++) {
    my ($Keyword) = $sth -> fetchrow_array;
    my $Boardname = $Keyword."Last";
    $query = qq!
      DELETE FROM $Boardname
      WHERE Username = $User_q
    !;
    $dbh -> do($query) or die "Can't execute $query.  Reason: $DBI::errstr.";
  }
  $sth -> finish; 

# ------------------------
# Send them a confirmation
  w3t::send_header ("The user has been deleted.","<META HTTP-EQUIV=\"Refresh\" content=\"5;url=$config{'cgiurl'}/admin/login.pl\">");
  w3t::table_header("The user has been deleted.");

  print "The user has been deleted.";

  w3t::send_footer();
