#!/usr/bin/perl 
###########################################################################
#    WWWThreads  - Interactive Discussion Forum
#    Rick Baker scream@screamingweb.com 
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
###########################################################################
  use w3tvars qw(%config);
  use w3t qw($dbh);
  use strict;


# -------------
# Get the input
  my %FORM = w3t::get_input();


# --------------------
# Assign the variables
  my $Keyword  = $FORM{'Keyword'};
  my $Total    = $FORM{'Total'};


# ----------------------
# Connect to the database
  w3t::db_connect();


# --------------------------
# Make sure this is an admin!
  my %user = w3t::authenticate();
  if ( ($user{'Status'} ne 'Administrator') && ($user{'Status'} ne 'Moderator') ){
    w3t::not_right ("You must be logged in, and be a valid administrator or moderator to access this.");
  }


# --------------------------------------------------------
# Lets cycle through the list and close the proper threads
  my $totalexpired = 0;
  for (my $i=0;$i<$Total;$i++){
    
    my $check    = "Thread$i";
    my $Closed_q = $dbh -> quote("K");
    my $Keyword_q = $dbh -> quote($Keyword);

    if( $FORM{$check} ) {

    # -----------------------------------------
    # Find out if there are any files to delete
      my $query = qq!
        SELECT Number
        FROM $Keyword
        WHERE Main = $FORM{$check}
      !;
      my $sti = $dbh -> prepare($query) or die "Query syntax error: $query. Reason: $DBI::errstr";
      $sti -> execute() or die "Can't execute query: $query. Reason: $DBI::errstr.";
      my $deletees = $sti -> rows;
      for (my $d=0;$d < $deletees;$d++) {
        my ($checkee) = $sti -> fetchrow_array;
        my $query = qq!
          SELECT File
          FROM $Keyword
          WHERE Number = $checkee
        !;
        my $stk = $dbh -> prepare($query) or die "Query syntax error: $query. Reason: $DBI::errstr";
        $stk -> execute() or die "Can't execute query: $query. Reason: $DBI::errstr.";
        my($filename) = $stk -> fetchrow_array;
        if ($filename) {
          unlink("$config{'files'}/$filename");
        }

      }

      my $query = qq!
        DELETE FROM $Keyword
        WHERE Main = $FORM{$check}
      !;
      
      my $rc = $dbh -> do ($query) or die "Can't execute query: $query. Reason: $DBI::errstr.";

      $totalexpired = $totalexpired + $rc;

    }

  }

# ----------------------------------------------
# Now we update the board to set the total posts
  my $Keyword_q = $dbh -> quote($Keyword);
  my $query = qq!
    UPDATE Boards
    SET Total = Total - $totalexpired
    WHERE Keyword = $Keyword_q
  !;
  my $rc = $dbh -> do ($query) or die "Can't execute query: $query. Reason: $DBI::errstr.";
 

# ------------------------
# Send them a page 
  w3t::send_header ("Threads expired","<META HTTP-EQUIV=\"Refresh\" content=\"5;url=$config{'cgiurl'}/admin/login.pl\">");
  w3t::table_header("Threads expired");

  print "$totalexpired All threads you marked to expire have been purged from the database.";

  w3t::send_footer();
