#!/usr/bin/perl 
###########################################################################
#    WWWThreads  - Interactive Discussion Forum
#    Rick Baker scream@screamingweb.com 
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
###########################################################################
  use w3tvars qw(%config);
  use w3t qw($dbh);
  use strict;


# ----------------------
# Connect to the database
  w3t::db_connect();


# -------------------------------------------
# Make sure this is an admin or a moderator!
  my %user = w3t::authenticate();
  if ( ($user{'Status'} ne 'Administrator') && ($user{'Status'} ne 'Moderator') ){

    w3t::not_right ("You must be logged in, and be a valid administrator or moderator to access this.");

  }

# ----------------------------------------------------------------------------
# If this is a moderator then they can only edit the boards that they moderate
  my $extra;
  if ( $user{'Status'} eq 'Moderator') {

    my $Username_q = $dbh -> quote($user{'Username'});
    $extra = "WHERE Moderator = $Username_q";
  
  }

  if ($extra) {
    $extra = $extra."\nAND Security <= $user{'Security'}";
  }
  else {
    $extra = "WHERE Security <= $user{'Security'}";
  } 

# -----------------------------------------------
# Grab the current boards
  my $query = qq!
    SELECT Title,Keyword
    FROM Boards
    $extra
  !;
  my $sth = $dbh -> prepare($query) or die "Query syntax error: $query. $DBI::errstr";
  $sth -> execute() or die "Can't execute query: $query. Reason: $DBI::errstr";

  my $rows = $sth -> rows;


# ------------------------
# Send them a page 
  w3t::send_header ("Choose a board.");
  w3t::table_header("Choose a board.");

  print "First choose a board and then you will be shown a list of threads for that board.";

  print "<FORM METHOD = POST action =\"$config{'cgiurl'}/admin/viewunkeptthreads.pl\">";
  print "<select name=\"Keyword\">";
  for (my $i=0;$i < $rows; $i++) {
  
    my ($Title,$Keyword) = $sth -> fetchrow_array;
    print "<option value=$Keyword>$Title</option>";  
    
  }
  print "</select>";
  print "<br><br>";
  print "<input type=submit value=\"View the Threads\">";


  $sth -> finish;
  w3t::send_footer();
