#!/usr/bin/perl
###########################################################################
#    WWWThreads  - Interactive Discussion Forum
#    Rick Baker scream@screamingweb.com 
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
###########################################################################
  use w3tvars qw(%config);
  use w3t qw($dbh);
  use strict;


# ---------------------------------------------------------
# Validate the user either from form input, or from cookies.
  w3t::db_connect;
  my %FORM     = w3t::get_input();
  my %user;  
  if ($FORM{'Username'} and $FORM{'Password'}) {
    %user = w3t::authenticate ($FORM{'Username'}, $FORM{'Password'});
  }
  else {
    %user = w3t::authenticate ();
  }


# ----------------------------------------------------------------------
# If we are not logged in, then present a log on form, otherwise present
# a menu of options.

  if( ($user{'Status'} ne 'Administrator') && ($user{'Status'} ne 'Moderator') ) {
    w3t::send_header("You must login first","<META HTTP-EQUIV=\"Refresh\" content=\"5;url=$config{'cgiurl'}/login.pl\">");

    w3t::table_header("You must login first");
    print qq~
      To access this section you must first be logged in.  You will be taken to the login screen shortly.
    ~;
    w3t::send_footer();
  }

# ------------------------------------------
# They are an admin so give them the options!
  elsif ($user{'Status'} eq 'Administrator') {


    w3t::set_cookie("Username", $user{'Username'},0,"Password",$user{'Password'},0);
    w3t::send_header ("Welcome, $user{'Username'}");
    w3t::table_header("Welcome, $user{'Username'}");
    print qq~
      As an Administrator the following options are available to you
     <p>
     <table border=0 width=100% cellspacing=0>
       <tr><td width=30% valign=top bgcolor=$config{'tddark'}>
         <a href="$config{'cgiurl'}/admin/assignmod.pl">
         Assign a Moderator
         </a>
       </td><td width=70% valign=top bgcolor=$config{'tddark'}>
         Choose a board and then choose a user to moderate it.
       </td></tr>

       <tr><td valign=top bgcolor=$config{'tdlight'}>
         <a href="$config{'cgiurl'}/admin/banuser.pl">
         Ban User / Host
         </a>
       </td><td valign=top bgcolor=$config{'tdlight'}>
         Ban a Username or Host from posting messages of any kind.
       </td></tr>

       <tr><td valign=top bgcolor=$config{'tddark'}>
         <a href="$config{'cgiurl'}/admin/changecatorder.pl">
         Change Category Order
         </a>
       </td><td valign=top bgcolor=$config{'tddark'}>
         Change the order that the categories are displayed. 
       </td></tr>

       <tr><td valign=top bgcolor=$config{'tdlight'}>
         <a href="$config{'cgiurl'}/admin/changeorder.pl">
         Change Order
         </a>
       </td><td valign=top bgcolor=$config{'tdlight'}>
         Change the order that the boards are displayed. 
       </td></tr>

       <tr><td valign=top bgcolor=$config{'tddark'}>
         <a href="$config{'cgiurl'}/admin/closethread.pl">
         Close Threads 
         </a>
       </td><td valign=top bgcolor=$config{'tddark'}>
         Mark a thread as closed, so no new posts can be made.
       </td></tr>

       <tr><td valign=top bgcolor=$config{'tdlight'}>
         <a href="$config{'cgiurl'}/admin/createboard.pl">
         Create Board
         </a>  
       </td><td valign=top bgcolor=$config{'tdlight'}>
         Create a new board.
       </td></tr>

       <tr><td valign=top bgcolor=$config{'tddark'}>
         <a href="$config{'cgiurl'}/admin/createcat.pl">
         Create Category 
         </a>  
       </td><td valign=top bgcolor=$config{'tddark'}>
         Create a new category so you can categorize your boards.
       </td></tr>

       <tr><td valign=top bgcolor=$config{'tdlight'}>
         <a href="$config{'cgiurl'}/admin/editboard.pl">
         Edit or delete a board
         </a>
       </td><td valign=top bgcolor=$config{'tdlight'}>
         Edit the title, description or any of the board options or you may delete the board.
       </td></tr>

       <tr><td valign=top bgcolor=$config{'tddark'}>
         <a href="$config{'cgiurl'}/admin/editcat.pl">
         Edit or delete a category 
         </a>
       </td><td valign=top bgcolor=$config{'tddark'}>
         Edit the title of an existing category or delete a category that contains no boards.
       </td></tr>

       <tr><td valign=top bgcolor=$config{'tdlight'}>
         <a href="$config{'cgiurl'}/admin/expirethreads.pl">
         Expire threads
         </a>
       </td><td valign=top bgcolor=$config{'tdlight'}>
         Mark certain threads to delete from the database
       </td></tr>

       <tr><td valign=top bgcolor=$config{'tddark'}>
         <a href="$config{'cgiurl'}/admin/grantadmin.pl">
         Grant Admin Privs
         </a>
       </td><td valign=top bgcolor=$config{'tddark'}>
         Grant Administrator privileges to another user.
       </td></tr>

       <tr><td valign=top bgcolor=$config{'tdlight'}>
         <a href="$config{'cgiurl'}/admin/keepthreads.pl">
         Keep Threads
         </a>
       </td><td valign=top bgcolor=$config{'tdlight'}>
         Mark certain threads as kept so they won't be deleted
       </td></tr>

       <tr><td valign=top bgcolor=$config{'tddark'}>
         <a href="$config{'cgiurl'}/admin/openthreads.pl">
         Open Threads 
         </a>
       </td><td valign=top bgcolor=$config{'tddark'}>
         Reopen threads that are currently marked as closed. 
       </td></tr>

       <tr><td valign=top bgcolor=$config{'tdlight'}>
         <a href="$config{'cgiurl'}/admin/revokeadmin.pl">
         Revoke Admin Privs
         </a>
       </td><td valign=top bgcolor=$config{'tdlight'}>
         Take away Administrative rights from another user.
       </td></tr>

  
       <tr><td valign=top bgcolor=$config{'tddark'}>
         <a href="$config{'cgiurl'}/admin/revokemod.pl">
         Revoke Moderator Privs
         </a>
       </td><td valign=top bgcolor=$config{'tddark'}>
         Take away Moderator rights from any user that is not assigned to a board.
       </td></tr>
 
       <tr><td valign=top bgcolor=$config{'tdlight'}>
         <a href="$config{'cgiurl'}/admin/selectusers.pl">
         Show/Edit Users 
         </a>
       </td><td valign=top bgcolor=$config{'tdlight'}>
         View, Edit or Delete registered Users.
       </td></tr>

       <tr><td valign=top bgcolor=$config{'tddark'}>
         <a href="$config{'cgiurl'}/admin/showstats.pl">
         Show Statistics
         </a>
       </td><td valign=top bgcolor=$config{'tddark'}>
         Get some statistics on number of users and posts per day.
       </td></tr>

       <tr><td valign=top bgcolor=$config{'tdlight'}>
         <a href="$config{'cgiurl'}/admin/unbanuser.pl">
         Unban User / Host
         </a>
       </td><td valign=top bgcolor=$config{'tdlight'}>
         Unban a Username or Hostname so they can post again.
       </td></tr>

       <tr><td valign=top bgcolor=$config{'tddark'}>
         <a href="$config{'cgiurl'}/admin/unkeepthreads.pl">
         Unkeep Threads 
         </a>
       </td><td valign=top bgcolor=$config{'tddark'}>
         Unmark kept threads so they will can be deleted. 
       </td></tr>


     </table>
    ~;
    w3t::send_footer();
  }


# --------------------------------------------
# They are a moderator so give them the options
  elsif ($user{'Status'} eq 'Moderator') {

    w3t::set_cookie("Username", $user{'Username'},0,"Password",$user{'Password'},0);
    w3t::send_header ("Welcome, $user{'Username'}");
    w3t::table_header("Welcome, $user{'Username'}");
    print qq~
      As a Moderator the following options are available to you.
      <p>
      <table border=0 width=100%>
       <tr><td valign=top bgcolor=$config{'tddark'}>
         <a href="$config{'cgiurl'}/admin/banuser.pl">
         Ban User / Host
         </a>
       </td><td valign=top bgcolor=$config{'tddark'}>
         Ban a Username or Host from posting messages of any kind.
       </td></tr>

       <tr><td valign=top bgcolor=$config{'tdlight'}>
         <a href="$config{'cgiurl'}/admin/closethread.pl">
         Close Threads
         </a>
       </td><td valign=top bgcolor=$config{'tdlight'}>
         Mark a thread as closed, so no new posts can be made.
       </td></tr>

       <tr><td width=30% valign=top bgcolor=$config{'tddark'}>
         <a href="$config{'cgiurl'}/admin/editboard.pl">
         Edit a board
         </a>
       </td><td width=70% valign=top bgcolor=$config{'tddark'}>
         Edit the title, description or any of the board options for any board that you moderate.
       </td></tr>

       <tr><td valign=top bgcolor=$config{'tdlight'}>
         <a href="$config{'cgiurl'}/admin/expirethreads.pl">
         Expire threads
         </a>
       </td><td valign=top bgcolor=$config{'tdlight'}>
         Mark certain threads to delete from the database
       </td></tr>

       <tr><td valign=top bgcolor=$config{'tddark'}>
         <a href="$config{'cgiurl'}/admin/keepthreads.pl">
         Keep Threads
         </a>
       </td><td valign=top bgcolor=$config{'tddark'}>
         Mark certain threads as kept so they won't be deleted
       </td></tr>

       <tr><td valign=top bgcolor=$config{'tdlight'}>
         <a href="$config{'cgiurl'}/admin/openthreads.pl">
         Open Threads
         </a>
       </td><td valign=top bgcolor=$config{'tdlight'}>
         Reopen threads that are currently marked as closed. 
       </td></tr>

       <tr><td valign=top bgcolor=$config{'tddark'}>
         <a href="$config{'cgiurl'}/admin/selectusers.pl">
         Show/Edit Users 
         </a>
       </td><td valign=top bgcolor=$config{'tddark'}>
         View or Edit registered Users.
       </td></tr>

       <tr><td valign=top bgcolor=$config{'tdlight'}>
         <a href="$config{'cgiurl'}/admin/showstats.pl">
         Show Statistics
         </a>
       </td><td valign=top bgcolor=$config{'tdlight'}>
         Get some statistics on number of users and posts per day.
       </td></tr>

       <tr><td valign=top bgcolor=$config{'tddark'}>
         <a href="$config{'cgiurl'}/admin/unbanuser.pl">
         Unban User / Host
         </a>
       </td><td valign=top bgcolor=$config{'tddark'}>
         Unban a Username or Hostname so they can post again.
       </td></tr>

       <tr><td valign=top bgcolor=$config{'tdlight'}>
         <a href="$config{'cgiurl'}/admin/unkeepthreads.pl">
         Unkeep Threads 
         </a>
       </td><td valign=top bgcolor=$config{'tdlight'}>
         Unmark kept threads so they will can be deleted. 
       </td></tr>
      </table>
    ~;
    w3t::send_footer();

  }
