#!/usr/bin/perl
###########################################################################
#    WWWThreads  - Interactive Discussion Forum
#    Rick Baker scream@screamingweb.com 
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
###########################################################################
  use w3tvars qw(%config);
  use w3t qw($dbh);

  use strict;


# -------------
# Get the input
  my %FORM = w3t::get_input();
  my $User = $FORM{'User'};


# -----------------------
# Connect to the database
  w3t::db_connect;


# -----------------------------------------
# Make sure this is an admin or a moderator
  my %user = w3t::authenticate();
  if ( ($user{'Status'} ne 'Administrator') && ($user{'Status'} ne 'Moderator')
){

    w3t::not_right ("You must be logged in, and be a valid administrator
or moderator to access this.");

  }


# Get the current profile for this username
  my $Username_q = $dbh -> quote($User);
  my $query = qq!
    SELECT Email,Fakeemail,Laston,Name,Signature,Homepage,Occupation,Hobbies,Location,Bio,Sort,Display,View,PostsPer,Number,EReplies,Notify,Status,Security
    FROM Users
    WHERE Username = $Username_q
  !;
  my $sth = $dbh -> prepare ($query) or die "Query syntax error: $DBI::errstr. Query: $query";
  $sth -> execute() or die "Can't execute query: $query. Reason: $DBI::errstr";


# --------------------------
# Assign the retrieved data
  my($Email,$Fakeemail,$Laston,$Name,$Signature,$Homepage,$Occupation,$Hobbies,$Location,$Bio,$Sort,$Display,$View,$PostsPer,$Number,$EReplies,$Notify,$Status,$Security) = $sth -> fetchrow_array;


# ------------------------------------------------------------------------
# If this is the very first admin, then they cannot view or edit this user
  if ($Number eq '1') {
    w3t::not_right("You cannot view or edit the first Administrator.");
  }


# ------------------------------------------------------------------------
# If this user is a moderator we have to make sure they are only looking at
# someone with User status
  if ( ($user{'Status'} eq 'Moderator') && ($Status ne 'User') ) {
    w3t::not_right("As a moderator you cannot view the profiles of other moderators or Admins");
  }  



# -----------------------------------------------
# Find out if they already have a sort preference
  if($Sort == 1) { $Sort = "Descending Subject"; } 
  if($Sort == 2) { $Sort = "Ascending Subject"; }
  if($Sort == 3) { $Sort = "Descending Poster"; } 
  if($Sort == 4) { $Sort = "Ascending Poster"; }
  if($Sort == 5) { $Sort = "Descending Date"; }
  if($Sort == 6) { $Sort = "Ascending Date"; }


# ----------------
# Convert the time
  $Laston = w3t::convert_time($Laston);


# ------------------------
# Convert returns to <br>s
  $Signature =~s /\n/<br>/g;
  $Bio =~s /\n/<br>/g;


# ---------------------------------------------------------
# Ok, we found the profile, now lets put it all onto a page
  w3t::send_header("Profile for $User");

  print qq~

  <table border=0 width=100% bgcolor=$config{'tddark'}>
  <tr><td>
  <font size = +2><b>
  Profile for $User 
  </b></font>
  </td></tr>
  </table>
  Security Level<br>
  <b>$Security
  <br><br>
  Email Address<br>
  <b>$Email</b>
  <br><br>
  Fake Email<br>
  <b>$Fakeemail</b>
  <br><br>
  Last On<br>
  <b>$Laston</b>
  <br><br>
  Full Name<br>
  <b>$Name</b>
  <br><br>
  Signature<br>
  <b>$Signature</b>
  <br><br>
  Homepage<br>
  <a href="http://$Homepage">http://$Homepage</a>
  <br><br>
  Occupation<br>
  <b>$Occupation</b>
  <br><br>
  Hobbies<br>
  <b>$Hobbies</b>
  <br><br>
  Geographic Location<br>
  <b>$Location</b>
  <br><br>
  Bio<br>
  <b>$Bio</b>
  <br><br>
  Default sort order<br>
  <b>$Sort</b>
  <br><br>
  Default display mode<br>
  <b>$Display</b>
  <br><br>
  Default view<br>
  <b>$View</b>
  <br><br>
  Total parent posts to show per page:<br>
  <b>$PostsPer</b>
  <br><br>
  Email notification for private messages?<br>
    <b>$Notify</b> 
  <br><br>
  Replies to posts emailed to this user<br>
  <b>$EReplies</b>
  <br><br>
~;

  print "User is subscribed to the following boards:<br>";
  my $query = qq!
    SELECT Board 
    FROM Subscribe
    WHERE Username = $Username_q
  !;
  my $sth = $dbh -> prepare($query) or die "Query syntax error: $query.  Reason: $DBI::errstr";
  $sth -> execute() or die "Can't execute query: $query. Reason: $DBI::errstr";
  my $rows = $sth -> rows;
  for (my $i=0; $i<$rows; $i++){

    my ($Keyword) = $sth -> fetchrow_array;
    my $Keyword_q = $dbh -> quote($Keyword);
    my $query =qq!
      SELECT Title
      FROM Boards
      WHERE Keyword = $Keyword_q
    !;
    my $sti = $dbh -> prepare($query) or die "Query syntax error: $query.  Reason: $DBI::errstr";
    $sti -> execute() or die "Can't execute query: $query. Reason: $DBI::errstr";
    my ($Title) = $sti -> fetchrow_array;
    print "<b>$Title</b><br>";

  }

  print "<br>";
  my $User = w3t::url_encode($User);
  print "<a href =\"$config{'cgiurl'}/admin/editoneuser.pl?User=$User\">Edit this user</a> &nbsp&nbsp | &nbsp;&nbsp;";
  print "<a href =\"$config{'cgiurl'}/admin/deleteuser.pl?User=$User\">Delete this user</a>";


# ----------------
# send the footer
  $sth -> finish;
  w3t::send_footer();
