#!/usr/bin/perl 
###########################################################################
#    WWWThreads  - Interactive Discussion Forum
#    Rick Baker scream@screamingweb.com 
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
###########################################################################
  use w3tvars qw(%config);
  use w3t qw($dbh);
  use strict;


# ----------------------
# Connect to the database
  w3t::db_connect();


# -------------------------------------------
# Make sure this is an admin or a moderator!
  my %user = w3t::authenticate();
  if ( ($user{'Status'} ne 'Administrator') && ($user{'Status'} ne 'Moderator') ){

    w3t::not_right ("You must be logged in, and be a valid administrator or moderator to access this.");

  }


# ------------------------
# Send them a page 
  w3t::send_header ("Stats for this site.");
  w3t::table_header("Stats for this site.");



# --------------------------------------------------------
# Lets find out the total number of users, admins and mods
  print "<table border=0 width=100% bgcolor=$config{'tableheader'} cellspacing=0>";
  print "<tr><td align=center colspan=3>Total Users</td></tr><tr>";
  

  my %status = (
    1 => 'User',
    2 => 'Administrator',
    3 => 'Moderator'
  );

  for (my $i=1;$i<4;$i++){

    my $check = $dbh -> quote($status{$i});
    my $query = qq!
      SELECT Number
      FROM Users
      WHERE Status = $check
    !;
    my $sth = $dbh -> prepare($query) or die "Query syntax error. $query. Reason: $DBI::errstr.";
    $sth -> execute() or die "Can't execute query: $query. Reason: $DBI::errstr.";
    my $rows = $sth -> rows;

    if ($rows < 1) { $rows = 0; }
    my $adder = '';
    if ($rows > 1) { $adder = "s"; }
 
    print "<td bgcolor=$config{'tdlight'} width = 33%>";
    print $rows. " $status{$i}"."$adder<br></td>";

  }
  print "</tr></table>";
  print "<p>&nbsp;";

# -----------------------------------------------------------
# We are going to show some stats on the boards here.
# First we need to find out when the very first post was made.
  my $query = qq!
    SELECT Title,Keyword,Last,Created
    FROM Boards
    ORDER BY Created
  !;
  my $sth = $dbh -> prepare($query) or die "Query syntax error. $query. Reason: $DBI::errstr.";
  $sth -> execute() or die "Can't execute query: $query. Reason: $DBI::errstr.";

  my $rows = $sth -> rows;
  my $days = 0;
  my $posts = 0;
  my $time  = '';
  my $end   = '';
  my $starttime = '';

# ----------------
# Set up the table
  print qq~
    <table border=0 width=100% cellspacing=0>
    <tr><td bgcolor=$config{'tableheader'}>Title</td>
    <td bgcolor=$config{'tableheader'}>Created on</td>
    <td bgcolor=$config{'tableheader'}>Avg. posts per day</td></tr>
  ~;
  my $color = $config{'tdlight'};

# -------------------------
# Cycle through the boards
  for (my $i=0; $i< $rows;$i++){

    my ($Title,$Keyword,$Last,$Created) = $sth -> fetchrow_array;
    $starttime ||= $Created;

    $time ||= $Created;
    $end  ||= $Created;

    while ($end < $Last) {

      $end  = $end + 86400;
      my $query = qq!
        SELECT Posted
        FROM $Keyword
        WHERE Posted > $time AND Posted < $end
      !;
      my $sti = $dbh -> prepare($query) or die "Query syntax error. $query. Reason: $DBI::errstr.";
      $sti -> execute() or die "Can't execute query: $query. Reason: $DBI::errstr.";

      my $totals = $sti -> rows;
      $posts = $posts + $totals;
      $days++;
      $time = $time + 86400;

    }

    my $avg;
    if ($days == 0) { 
      $avg = "No data yet"; 
    }
    else {
      $avg = ( int(100*($posts / $days)) / 100.0 );
    }
    print "<tr><td bgcolor=$color>$Title</td><td bgcolor=$color>\n";
    my $Createdon = w3t::convert_time($Created);
    print "$Createdon</td><td bgcolor=$color>\n";
    print "$avg</td></tr>";
    
    $posts = 0;
    $days  = 0;        
    $end   = '';
    $time  = $starttime;
    $end   = $starttime;
    if ($color eq $config{'tdlight'}) {
      $color = $config{'tddark'};
    }
    else {
      $color = $config{'tdlight'};
    }

  }
  print "</table>";


  $sth -> finish;
  w3t::send_footer();
