#!/usr/bin/perl 
###########################################################################
#    WWWThreads  - Interactive Discussion Forum
#    Rick Baker scream@screamingweb.com 
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
###########################################################################
  use w3tvars qw(%config);
  use w3t qw($dbh);
  use strict;


# -------------
# Get the input
  my %FORM  = w3t::get_input();
  my $Start = $FORM{'Start'};


# ----------------------
# Connect to the database
  w3t::db_connect();


# -------------------------------------------
# Make sure this is an admin or a moderator!
  my %user = w3t::authenticate();
  if ( ($user{'Status'} ne 'Administrator') && ($user{'Status'} ne 'Moderator') ){

    w3t::not_right ("You must be logged in, and be a valid administrator or moderator to access this.");

  }


# ------------------------
# Send them a page 
  w3t::send_header ("Registered Users");
  w3t::table_header("Registered Users");


# -----------------------------------------------------------------------
# If this is a moderator then they can only look up Users with the Status
# of User
  my $status = '';
  my $check  = '';
  if ($user{'Status'} eq 'Moderator') {
    $status = "User";
    my $status_q = $dbh -> quote($status);
    $check = "WHERE Status = $status_q";
  }


# ----------------
# Format the query
  my $format = '';
  if ($Start =~/[A-Z]/){
    my $part = "$Start"."%";
    my $part_q = $dbh -> quote($part);
    $format = "WHERE Username Like $part_q";
    if ($check) {
      $format .=" AND ";
    }
  }
  elsif ($Start eq "0-9"){
    my $zero  = $dbh->quote("0%");
    my $one   = $dbh->quote("1%");
    my $two   = $dbh->quote("2%");
    my $three = $dbh->quote("3%");
    my $four  = $dbh->quote("4%");
    my $five  = $dbh->quote("5%");
    my $six   = $dbh->quote("6%");
    my $seven = $dbh->quote("7%");
    my $eight = $dbh->quote("8%");
    my $nine  = $dbh->quote("9%");
    $format = qq!
      WHERE Username Like $zero
      OR Username Like $one
      OR Username Like $two
      OR Username Like $three
      OR Username Like $four
      OR Username Like $five
      OR Username Like $six
      OR Username Like $seven
      OR Username Like $eight
      OR Username Like $nine
    !;
    if ($check) {
      $format .=" AND ";
    }
  }
  if ($Start eq "All Users") {
    $format = "";
  }
 
  my $query = qq!
    SELECT Username,Number 
    FROM Users
    $format
    $check
    ORDER BY Username
  !;
  my $sth = $dbh -> prepare($query) or die "Query syntax error. $query. Reason: $DBI::errstr.";
  $sth -> execute() or die "Can't execute query: $query. Reason: $DBI::errstr.";
  my $rows = $sth -> rows;

  for (my $i=0; $i<$rows; $i++){

    my ($User,$Number) = $sth->fetchrow_array;
    if ($Number ne '1') {
      my $EUser = w3t::url_encode($User);
      print "<a href=\"$config{'cgiurl'}/admin/showoneuser.pl?User=$EUser\">$User</a><br>\n";
    }

  }

  $sth -> finish;
  w3t::send_footer();
