#!/usr/bin/perl 
###########################################################################
#    WWWThreads  - Interactive Discussion Forum
#    Rick Baker scream@screamingweb.com 
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
###########################################################################
  use w3tvars qw(%config);
  use w3t qw($dbh);
  use strict;


# ------------
# Get the input
  my %FORM = w3t::get_input();


# --------------------
# Assign the variables
  my $Number = $FORM{'Number'};


# ----------------------
# Connect to the database
  w3t::db_connect();


# --------------------------
# Make sure this is an admin!
  my %user = w3t::authenticate();
  if ($user{'Status'} ne 'Administrator') {
    w3t::not_right ("You must be logged in, and be a valid administrator to access this.");
  }


# -----------------------------------------------
# Grab the board info 
  my $query = qq!
    SELECT Title,Keyword,Number,Moderator
    FROM Boards
    WHERE Number = $Number
  !;
  my $sth = $dbh -> prepare($query) or die "Query syntax error: $query. $DBI::errstr";
  $sth -> execute() or die "Can't execute query: $query. Reason: $DBI::errstr";

  my ($Title,$Keyword,$Number,$Moderator) = $sth -> fetchrow_array;

# ------------------------
# Send them a page 
  w3t::send_header ("Assign a moderator.");
  w3t::table_header("Assign a moderator.");

  print "Title: $Title<br>";
  print "Current Moderator: $Moderator<br><br>";


# ---------------------
# Get all the usernames
  my $query = qq!
    SELECT Username
    FROM Users 
    ORDER BY Username
  !;
  my $sth = $dbh -> prepare($query) or die "Query syntax error: $DBI::errstr.";
  $sth -> execute() or die "Can't execute query: $query. Reason: $DBI::errstr.";

  print "Choose the User that you would like to moderate this board.<br>";
  print "<FORM METHOD = POST action =\"$config{'cgiurl'}/admin/doassignmod.pl\">";
  print "<input type=hidden name=Keyword value=\"$Keyword\">";
  print "<input type=hidden name=Title value =\"$Title\">";
  print "<select name = \"Username\" size = 15>";
  my $Username = '';
  my $rows = $sth -> rows;

  for (my $i=0; $i < $rows; $i++){
    ($Username) = $sth->fetchrow_array;
    print "<option>$Username</option>\n";
  }
  print "</select>";
  print "<br><br>";
  print "<input type=submit value=\"Submit\">";
  print "</form>";  

  $sth -> finish;
  w3t::send_footer();
