#!/usr/bin/perl
###########################################################################
#    WWWThreads  - Interactive Discussion Forum
#    Rick Baker scream@screamingweb.com 
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
###########################################################################
  use w3tvars qw(%config);
  use w3t qw($dbh);
  use strict;

# -------------
# Get the input
  my %FORM = w3t::get_input();


# -------------------
# Assign the variable
  my $Title = $FORM{'Title'};


# ----------------------
# Connect to the database
  w3t::db_connect();


# --------------------------
# Make sure this is an admin!
  my %user = w3t::authenticate();
  if ($user{'Status'} ne 'Administrator') {
    w3t::not_right ("You must be logged in, and be a valid administrator to access this.");
  }


# -----------------------------------------------
# Grab the current boards and display there order
  my $Title_q = $dbh -> quote($Title);
  my $NULL_q  = $dbh -> quote("NULL");
  my $query = qq!
    SELECT Title,Keyword,Sorter
    FROM Category
    WHERE Title = $Title_q
    AND Keyword <> $NULL_q
    ORDER BY Sorter 
  !;
  my $sth = $dbh -> prepare($query) or die "Query syntax error: $query. $DBI::errstr";
  $sth -> execute() or die "Can't execute query: $query. Reason: $DBI::errstr";

  my $rows = $sth -> rows;


# ------------------------
# Send them a confirmation
  w3t::send_header ("Sort the forum order.");

  w3t::table_header("Sort the forum order.");

  print "Below you can change the order that the forums are displayed.  Make sure you assign each board an individual number starting at 1<p>";

  print "<FORM METHOD = POST action =\"$config{'cgiurl'}/admin/dochangeorder.pl\">";

  for (my $i=0;$i < $rows; $i++) {
  
    my ($Title,$Keyword,$Number) = $sth -> fetchrow_array;
    my $Keyword_q = $dbh -> quote($Keyword);
    my $query = qq!
      SELECT Title
      FROM Boards
      WHERE Keyword = $Keyword_q
    !;
    my $sti = $dbh -> prepare($query) or die "Query syntax error: $query. $DBI::errstr";
    $sti -> execute() or die "Can't execute query: $query. Reason: $DBI::errstr";
    my ($Title) = $sti -> fetchrow_array;
    $sti -> finish;
    $Number = $i+1;
    print "<input type=text size=2 name=\"$Keyword\" value=$Number> $Title<br>";
    
  }
  print "<br><br>";
  print "<input type=hidden name=Title value=\"$Title\">";
  print "<input type=submit value=\"Change order\">";
  print "</form>";  

  $sth -> finish;
  w3t::send_footer();
