#!/usr/bin/perl
###########################################################################
#    WWWThreads  - Interactive Discussion Forum
#    Rick Baker scream@screamingweb.com 
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
###########################################################################
  use w3tvars qw(%config);
  use w3t qw($dbh);

  use DBI;
  use strict;

  w3t::db_connect;
  my $statement = '';
  my $sth       = '';
  my $rc        = '';


# ---------------------
# Alter the Board Table
  print "Altering the Boards Table...\n";
  $statement = qq!
    ALTER TABLE Boards
    ADD Markup CHAR(3) NOT NULL DEFAULT "On",
    ADD Approve CHAR(3) NOT NULL DEFAULT "Off"
  !;

  $dbh -> do ($statement) or die "Can't execute query. Reason: $DBI::errstr";


# ---------------------
# Alter the Users table
  print "Altering the Users Table...\n";
  $statement = qq!
    ALTER TABLE Users
    Add FontSize CHAR(4) DEFAULT "0",
    Add FontFace CHAR(30) DEFAULT "",
    Add Extra1 CHAR(200),
    Add Extra2 CHAR(200),
    Add Extra3 CHAR(200),
    Add Extra4 CHAR(200),
    Add Extra5 CHAR(200)
  !;

  $dbh -> do ($statement) or die "Can't execute query. Reason: $DBI::errstr";
   

# ----------------------
# Add the category table
  print "Creating the Category Table...\n";
  $statement = qq!
    CREATE TABLE Category(
      Title CHAR(120) NOT NULL DEFAULT "General Discussion",
      Number INT(9) UNSIGNED DEFAULT '0' NOT NULL,
      Keyword CHAR(100),
      Sorter INT(9) UNSIGNED DEFAULT '0' NOT NULL AUTO_INCREMENT,
      INDEX indx1 (Title),
      INDEX indx2 (Sorter)
    )
  !;
  $dbh -> do ($statement) or die "Can't execute query. Reason: $DBI::errstr.";


# ------------------------------------------------
# Add the existing boards into the "Main" Category
  print "Adding the existing forums into the \"General Discussion\" category...\n";
  $statement = qq!
    SELECT Keyword,Number
    FROM Boards
    ORDER BY Number
  !;
  $sth = $dbh -> prepare($statement) or die "Can't prepare query.  Reason: $DBI::errstr.";
  $sth -> execute() or die "Can't execute query.  Reason: $DBI::errstr.";

  while (my (@varlist) = $sth -> fetchrow_array) {
    my $Title_q   = $dbh -> quote("General Discussion");
    my $Keyword_q = $dbh -> quote($varlist[0]);
    $statement = qq!
      INSERT INTO Category
      (Title,Number,Keyword,Sorter) 
      VALUES ($Title_q,1,$Keyword_q,$varlist[1])
    !;
    $dbh -> do ($statement) or die "Can't execute query. Reason: $DBI::errstr.";
  }
    
# ---------------------
# Give the confirmation

  print "Done\n\n";
 

  
