#!/usr/bin/perl
###########################################################################
#    WWWThreads  - Interactive Discussion Forum
#    Rick Baker scream@screamingweb.com 
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
###########################################################################
  use w3tvars qw(%config);
  use w3t qw($dbh);

  use DBI;
  use strict;

  w3t::db_connect;
  my $statement = '';
  my $sth       = '';
  my $rc        = '';


# ---------------------
# Alter the Board Table
  print "Dropping the Keywords Table...\n";
  $statement = qq!
    DROP TABLE Keywords
  !;

  $dbh -> do ($statement) or die "Can't execute query. Reason: $DBI::errstr";

# ---------------------
# Alter the Users table
  my $time = w3t::get_date();
  print "Adding Post Format and Registered field to User's Table and setting existing users Registered field to todays date...\n";
  $statement = qq!
    ALTER TABLE Users 
    ADD Post_Format CHAR(5) NOT NULL DEFAULT "$config{'post_format'}",
    ADD Registered INT(11) NOT NULL DEFAULT '$time'
  !;

  $dbh -> do ($statement) or die "Can't execute query. Reason: $DBI::errstr";

# ---------------------------------------------------
# Upgrade the first admin's security level to the max
  print "Upgrading the root administrator's security level to 100...\n";
  $statement = qq!
    UPDATE Users SET Security = '100'
    WHERE Number = 1
  !;
  $dbh -> do ($statement) or die "Can't execute query. Reason: $DBI::errstr";

# -------------------------------------------
# Alter each boards table to add Posted Index
  print "Indexing the Posted field on each board to increase search speed...\n";
  $statement = qq!
    SELECT Keyword
    FROM Boards
  !;
  $sth = $dbh -> prepare($statement) or die "Can't prepare query.  Reason: $DBI::errstr.";
  $sth -> execute() or die "Can't execute query.  Reason: $DBI::errstr.";

  while (my (@varlist) = $sth -> fetchrow_array) {
    $statement = qq!
      ALTER TABLE $varlist[0] 
      ADD KEY indx_posted(Posted) 
    !;
    $dbh -> do ($statement) or die "Can't execute query. Reason: $DBI::errstr.";
  }


# ---------------------
# Give the confirmation

  print "Done\n\n";
 

  
