#!/usr/bin/perl 
###########################################################################
#    WWWThreads  - Interactive Discussion Forum
#    Rick Baker scream@screamingweb.com 
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
###########################################################################

  BEGIN {
    unshift(@INC, "/home/httpd/perl");
  }
  use w3tvars qw(%config);
  use w3t qw($dbh);

  use strict;


# -----------------------
# Connect to the database
  w3t::db_connect();


# ----------------------------------------------------
# First we grab the board keywords and the expire time
  my $query = qq!
    SELECT Keyword,Expire
    FROM Boards
    WHERE Expire <> 0
  !;
  my $sth = $dbh -> prepare($query) or die "Query syntax error: $query.  Reason: $DBI::errstr";
  $sth -> execute() or die "Can't execute query: $query.  Reason: $DBI::errstr";

  my $rows = $sth -> rows;


# ----------------------------------------------------------
# Now we cycle through all the boards that have an expire set
  for (my $i=0; $i<$rows; $i++){
    
    my ($Keyword,$Expires) = $sth -> fetchrow_array;
    
  # Now we cycle through all the threads and grab all the main posts that 
  # are older than the expiration date
    my $currtime   = w3t::get_date();
    my $expiretime = $currtime - ($Expires * 86400);
    my $Kept_q     = $dbh -> quote("K");

    my $query = qq!
      SELECT Number,Main FROM $Keyword
      WHERE Main = Number
      AND Kept <> $Kept_q
      AND Last_Post < $expiretime
    !;
    my $sti = $dbh -> prepare($query) or die "Query syntax error: $query.  Reason: $DBI::errstr";
    $sti -> execute() or die "Can't execute query: $query.  Reason: $DBI::errstr";

    my $mrows = $sti -> rows;

  # -------------------------------------------------
  # Now we cycle through these threads and purge them
  # and remove them from the keywords table
    my $Keyword_q = $dbh -> quote($Keyword);
    my $totalexpired = 0;
    for (my $j=0; $j< $mrows; $j++){

      my ($Mnumber,$Main) = $sti -> fetchrow_array;

    # -----------------------------------------
    # Find out if there are any files to delete
      my $query = qq!
        SELECT Number
        FROM $Keyword
        WHERE Main = $Mnumber
      !;
      my $sta = $dbh -> prepare($query) or die "Query syntax error: $query. Reason: $DBI::errstr";
      $sta -> execute() or die "Can't execute query: $query. Reason: $DBI::errstr.";
      my $deletees = $sta -> rows;
      for (my $d=0;$d < $deletees;$d++) {
        my ($checkee) = $sta -> fetchrow_array;
        my $query = qq!
          SELECT File
          FROM $Keyword
          WHERE Number = $checkee
        !;
        my $stk = $dbh -> prepare($query) or die "Query syntax error: $query. Reason: $DBI::errstr";
        $stk -> execute() or die "Can't execute query: $query. Reason: $DBI::errstr.";
        my($filename) = $stk -> fetchrow_array;
        if ($filename) {
          unlink("$config{'files'}/$filename");
        }

      }

      my $query = qq!
        DELETE FROM $Keyword
        WHERE Main = $Mnumber  
      !;
      my $rc = $dbh -> do($query) or die "Can't execute query: $query.  Reason: $DBI::errstr";
      
      $totalexpired = $totalexpired + $rc;

    }

  # ---------------------------------------------
  # Now we update the board to set the total posts
    my $Keyword_q = $dbh -> quote($Keyword);

    my $query = qq!
      UPDATE Boards
      SET Total = Total - $totalexpired
      WHERE Keyword = $Keyword_q
    !;
    my $rc = $dbh -> do($query) or die "Can't execute query: $query.  Reason: $DBI::errstr";
  

  }
  


  $sth -> finish;
  w3t::db_disconnect(); 
