#!/usr/bin/perl 
###########################################################################
#    WWWThreads  - Interactive Discussion Forum
#    Rick Baker scream@screamingweb.com 
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
###########################################################################

  BEGIN {
    unshift(@INC, "/home/httpd/perl");
  }
  use w3tvars qw(%config);
  use w3t qw($dbh);

  use strict;
  use Mailer;


# -----------------------
# Connect to the database
  w3t::db_connect();


# ---------------------------------------------- 
# First we grab all boards that have subscribers
  my $query = qq!
    SELECT DISTINCT Board
    FROM Subscribe
  !;
  my $sth = $dbh -> prepare($query) or die "Query syntax error: $query. Reason: $DBI::errstr";
  $sth -> execute() or die "Can't execute query: $query.  Reason: $DBI::errstr";
  my $rows = $sth -> rows;


# ----------------------------------------------------------------
# Now we have the boards we need to cycle through the subscribers 
  for (my $j = 0;$j < $rows; $j++ ) {
    my ($Board) = $sth -> fetchrow_array;
    my $Board_q       = $dbh -> quote($Board);

    my $query = qq!
      SELECT Title
      FROM Boards
      WHERE Keyword = $Board_q
    !;
    my $sta = $dbh -> prepare($query) or die "Query syntax error: $query. Reason: $DBI::errstr";
    $sta -> execute() or die "Can't execute query: $query.  Reason: $DBI::errstr";
    my ($Title) = $sta -> fetchrow_array;


    my $query = qq!
      SELECT Username,Last
      FROM Subscribe
      WHERE Board = $Board_q
    !;
    my $sti = $dbh -> prepare($query) or die "Query syntax error: $query. Reason: $DBI::errstr";
    $sti -> execute() or die "Can't execute query: $query.  Reason: $DBI::errstr";
    my $userrows = $sti -> rows;
 

    # ---------------------------------------------------------
    # Now that we have all the users we need to cycle through 
      for (my $k = 0; $k < $userrows; $k++) {

        # ---------------------------------------
        # Now we need to grab their email address
          my ($Username,$Last)   = $sti -> fetchrow_array;
          my $Username_q = $dbh -> quote($Username);
          my $query = qq!
            SELECT Email
            FROM Users
            WHERE Username = $Username_q
          !;
          my $stj = $dbh -> prepare($query) or die "Query syntax error: $query. Reason: $DBI::errstr";
          $stj -> execute() or die "Can't execute query: $query.  Reason: $DBI::errstr";
          my ($Email) = $stj -> fetchrow_array;

        # ------------------------------
        # Now we grab all the posts info 
          my $query = qq!
            SELECT Number,Posted,Username,IP,Subject,Body
            FROM $Board
            WHERE Number > $Last
            ORDER BY Number ASC
          !;
          my $stk = $dbh -> prepare($query) or die "Query syntax error: $query. Reason: $DBI::errstr";
          $stk -> execute() or die "Can't execute query: $query.  Reason: $DBI::errstr";
          my $postrows = $stk -> rows;
          my $seperator = "----------------------------------------------------------------------\n";
          my $message  = "The following is a list of all posts made on the forum '$Title' for the past day.  The forum location is $config{'cgiurl'}/wwwthreads.pl\n$seperator$seperator\n";  

        # ------------------------------------------------------
        # Only send out an email if there are posts for the day
          if($postrows > 0){


          # --------------------------------------------------------
          # Now we cycle through the posts and append to the message
            my ($Number,$PPosted,$PUsername,$PIP,$PSubject,$PBody);
            for (my $l =0; $l < $postrows; $l++) {
              ($Number,$PPosted,$PUsername,$PIP,$PSubject,$PBody) = $stk -> fetchrow_array;
              $message = $message .   "Subject:   $PSubject\n";
              $message = $message .   "Poster:    $PUsername\n";
              my $date = w3t::convert_time($PPosted);
              $message = $message .   "Posted on: $date\n";
              $PBody =~s /<br>/\n/g;
              $message = $message . "\n$PBody\n\n";
              $message = $message . "$seperator$seperator\n";
    
            }

          # ------------------------------------
          # Now we need to update the last entry
            my $query = qq!
              UPDATE Subscribe
              SET Last = $Number
              WHERE Board = $Board_q AND Username = $Username_q
            !;
            my $rc = $dbh -> do($query) or die "Can't execute query: $query.  Reason: $DBI::errstr";


             my $mailer = new Mailer ( { smtp => $config{'SMTP'}, sendmail => $config{'sendmail'} } ) or die "Can't init: $Mailer::error";
             my $to   = $Email;
             my $from = $config{'emailaddy'};
             my $subject = "Daily archive of $Title";
             $mailer -> send( {to => $to, from => $from, subject => $subject, msg => $message} ) or die "Can't mail message: $Mailer::error";

          }

      } 

  }

  $sth -> finish;
  w3t::db_disconnect(); 
