#!/usr/bin/perl
###########################################################################
#    WWWThreads  - Interactive Discussion Forum
#    Rick Baker scream@screamingweb.com 
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
###########################################################################
  use w3tvars qw(%config);
  use w3t qw($dbh);

  use strict;


# -----------------------
# Connect to the database
  w3t::db_connect();
  my $query = '';
  my $sth   = '';
  my $rows  = '';


# --------------------
# Authenticate the user
  my %cookie   = w3t::get_cookie();
  my $Username = $cookie{'Username'};
  my $Password = $cookie{'Password'};
  my %user     = w3t::authenticate($Username,$Password);
  if (!( defined $user{'Username'} ) ) {

    w3t::not_right ("We could not authenticate your Username/Passord.");

  }


# Get the current profile for this username
  my $Username_q = $dbh -> quote($user{'Username'});
  $query = qq!
    SELECT Password,Email,Fakeemail,Name,Signature,Homepage,Occupation,Hobbies,Location,Bio,Sort,Display,View,PostsPer,EReplies,Notify,TextCols,TextRows,FontSize,FontFace,Extra1,Post_Format,Preview
    FROM Users
    WHERE Username = $Username_q
  !;
  $sth = $dbh -> prepare ($query) or die "Query syntax error: $DBI::errstr. Query: $query";
  $sth -> execute() or die "Can't execute query: $query. Reason: $DBI::errstr";


# --------------------------------
# Make sure we found this Username
  $rows = $sth -> rows;

  if ($rows < 1){

    $sth -> finish;
    w3t::not_right("We could not find a profile for the Username '$user{'Username'}'");

  }


# --------------------------
# Assign the retrieved data
  my($Password,$Email,$Fakeemail,$Name,$Signature,$Homepage,$Occupation,$Hobbies,$Location,$Bio,$Sort,$Display,$View,$PostsPer,$EReplies,$Notify,$TextCols,$TextRows,$FontSize,$FontFace,$ICQ,$Post_Format,$Preview) = $sth -> fetchrow_array;
  $TextCols ||= "80";
  $TextRows ||= "5";


# -----------------------------------------------
# Find out if they already have a sort preference
  my $DS = '';
  my $AS = '';
  my $DP = '';
  my $AP = '';
  my $DD = '';
  my $AD = '';
  if($Sort == 1) { $DS = "selected"; } 
  if($Sort == 2) { $AS = "selected"; }
  if($Sort == 3) { $DP = "selected"; } 
  if($Sort == 4) { $AP = "selected"; }
  if($Sort == 5) { $DD = "selected"; }
  if($Sort == 6) { $AD = "selected"; }


# --------------------------------------------------
# Find out if they already have a display preference
  my $flat     = '';
  my $threaded = '';
  if($Display eq "flat")     { $flat = "selected"; };
  if($Display eq "threaded") { $threaded = "selected"; }


# ---------------------------------------
# Find out if they have a view preference
  my $collapsed = '';
  my $expanded  = '';
  if($View eq "collapsed") { $collapsed = "selected"; }
  if($View eq "expanded")  { $expanded  = "selected"; }

# -------------------------------
# FInd out their post format pref
  my $side = '';
  my $top  = '';
  if ($Post_Format eq "top") { $top = "selected"; }
  if ($Post_Format eq "side") { $side = "selected"; }
  
# -------------------------------
# Find out if they preview or not
  my $previewon  = '';
  my $previewoff = '';
  if ($Preview eq "on")  { $previewon = "selected"; }
  if ($Preview eq "off") { $previewoff = "selected"; }

# ---------------------------------
# Set the default for Email replies
  my $ereplies   = '';
  my $noereplies = '';

  if($EReplies eq "Off") { 
    $noereplies = "checked"; 
  }
  else {
    $ereplies = "checked";
  }


# ------------------------------------------------
# Set the default for private message notification
  my $donotify = '';
  my $nonotify = '';

  if ($Notify eq "On") {
    $donotify = "checked";
  }
  else {
    $nonotify = "checked";
  }


# ------------------------
# Convert returns to <br>s
  $Signature =~s /<br>/\n/g;
  $Bio =~s /<br>/\n/g;


# ---------------------------
# Change the quotes to &quot;
  $Password =~s /"/&quot;/g;
  $Email =~s /"/&quot;/g;
  $Fakeemail =~s /"/&quot;/g;
  $Signature =~s /"/&quot;/g;
  $Homepage =~s /"/&quot;/g;
  $Occupation =~s /"/&quot;/g;
  $Hobbies =~s /"/&quot;/g;
  $Location =~s /"/&quot;/g;
  $Bio =~s /"/&quot;/g;


# ---------------------------------------------------------
# Ok, we found the profile, now lets put it all onto a page
  w3t::send_header("Profile for $user{'Username'}");
  w3t::table_header("Edit profile for $user{'Username'}");
  print qq~
  <table cellspacing=0 border=0 width=100% bgcolor=$config{'tddark'}>
  <tr><td>
  You can edit any of the information below.
  </p><p>
  </td></tr><tr><td bgcolor=$config{'tdlight'}>
  <form method = POST action = "$config{'cgiurl'}/changeprofile.pl">
  <input type = hidden name = Username value ="$user{'Username'}">
  <input type = hidden name = OldPass value = "$Password">
  <p>
  <b><font color=$config{'headerfontcolor'}>Basic Profile</font></b>
  <hr size=1 noshade>
  Password (between 4 and 20 characters)<br>
  <input type = password name=Password value = "$Password" maxlength=20>
  <p> 
  Verify Password<br>
  <input type = password name = Verify value = "$Password" maxlength=20>
  <p> 
  Email Address (Not available to other users)<br>
  <input type = text name = Email value = "$Email">
  <p> 
  Fake Email (shown on your profile page to other users)<br>
  <input type = text name = Fakeemail value = "$Fakeemail">
  <p> 
  Full Name<br>
  <input type = text name = Name value = "$Name">
  <p> 
  Signature (up to $config{'Sig_length'} characters) You may use <a href="$config{'cgiurl'}/faq.pl#html">Markup</a> in your signature<br>
  <textarea name=Signature cols=50 rows=3 wrap=soft>$Signature</textarea>
  <p> 
  Homepage (up to 150 characters)<br>
  http://<input type=text name=Homepage value = "$Homepage">
  <p> 
  Occupation<br>
  <input type=text name=Occupation value = "$Occupation">
  <p> 
  Hobbies (up to 200 characters)<br>
  <input type=text name=Hobbies value = "$Hobbies">
  <p> 
  Geographic Location (State, Country, etc.)<br>
  <input type=text name=Location value = "$Location">
  <p> 
  Bio (up to 250 characters)<br>
  <textarea name=Bio cols=$TextCols rows=$TextRows wrap=soft>$Bio</textarea>
  <p> 
  ~;
  if ($config{'extra1'}) {
    print "ICQ Number<br>";
    print "<input type=text name=ICQ value=\"$ICQ\">";
    print "<p>";
  }
  print qq~
  <p>
  <b><font color=$config{'headerfontcolor'}>Display Preferences</font></b>
  <hr size=1 noshade>
  Default sort order<br>
  <select name = "sort_order">
    <option value = 1 $DS>Descending Subject</option>
    <option value = 2 $AS>Ascending Subject</option>
    <option value = 3 $DP>Descending Poster</option>
    <option value = 4 $AP>Ascending Poster</option>
    <option value = 5 $DD>Descending Date</option>
    <option value = 6 $AD>Ascending Date</option>
  </select>
  <p>
  Default display mode<br>
  <select name = "display">
    <option value = "threaded" $threaded>Threaded Mode</option>
    <option value = "flat" $flat>Flat Mode</option>
  </select>
  <p>
  Default view<br>
  <select name = "view">
    <option value = "collapsed" $collapsed>Collapsed Threads</option>
    <option value = "expanded"  $expanded>Expanded Threads</option>
  </select>
  <p>
  Total parent posts to show per page: (default is $config{'postsperpage'})<br>
  <input type=text name=PostsPer maxlength = 3 size = 3 value = $PostsPer><br><br>
  <p> 
  Post Format - ( top = Post headers on top : side = Post headers on the left )<br>
  <select name = "Post_Format">
    <option value = "side" $side>Side</option>
    <option value = "top"  $top>Top</option>
  </select>
  <p>
  Do you want the preview post screen off or on? <br>
  <select name = "Preview">
    <option value = "off" $previewoff>Off</option>
    <option value = "on"  $previewon>On</option>
  </select>
  <p>
  How many columns would you like your TextArea's set at?<br>
    <input type=text name = TextCols value = "$TextCols">
  <p> 
  How many rows would you like your TextArea's set at?<br>
    <input type=text name = TextRows value = "$TextRows">
  <p>
  Increase or Decrease font size by how many points. (ie. -1 or -2, decreases the font size.  1 or 2, would increase the font size)<br>
    <input type=text name = FontSize size=2 value = "$FontSize">
  <p> 
  Set the default font to use.  System default is <i>$config{'fontface'}</i>.<br>
    <input type=text name = FontFace value = "$FontFace">
  <p>


  <b><font color=$config{'headerfontcolor'}>Email Notifications / Subscriptions</font></b>
  <hr size=1 noshade>
  Do you want email notification when you receive private messages?<br>
    <input type=radio name=Notify value="Off" $nonotify> No
    <input type=radio name=Notify value="On" $donotify> Yes

  <p> 
  Do you want all replies to posts that you make emailed to you?<br>
    <input type=radio name=EReplies value="Off" $noereplies> No
    <input type=radio name=EReplies value="On" $ereplies> Yes
  <p> 
~;

# ------------------------------------------------------------------
# if we are allowing subscribes then we need to put that on the page
  if ($config{'subscriptions'}) {

  # -----------------------------------------
  # Grab the keyword and titles of all boards
    my $query = qq!
      SELECT Title,Keyword,Security
      FROM Boards
      WHERE Security <= $user{'Security'}
      ORDER BY Title
    !;
    $sth = $dbh -> prepare ($query) or die "Query syntax error: $DBI::errstr. Query: $query";
    $sth -> execute() or die "Can't execute query: $query. Reason: $DBI::errstr";
    my $rows = $sth -> rows;
    print "Subscription status for the following boards.  (Receive a daily archive of all posts to this board via your Real email address.)<p>";

    for (my $i = 0; $i < $rows; $i++) {

      my ($Title,$Keyword) = $sth -> fetchrow_array;
    
    # ------------------------------------
    # check if they are already subscribed
      my $Username_q = $dbh -> quote($user{'Username'});
      my $Keyword_q  = $dbh -> quote($Keyword);

      my $query = qq!
        SELECT Last
        FROM Subscribe
        WHERE Username = $Username_q AND Board = $Keyword_q
      !;
      my $sti = $dbh -> prepare ($query) or die "Query syntax error: $DBI::errstr. Query: $query";
      $sti -> execute() or die "Can't execute query: $query. Reason: $DBI::errstr";
      my $rows = $sti -> rows;
      my $Sub = '';
      my $Nosub = '';
      if ($rows > 0) { 
        $Sub = "checked"; 
      }
      else {
        $Nosub = "checked";
      }
      
      print "$Title<br>";
      my $Word = "$Keyword"."--SUB--YES";
      print "<input type=radio name=\"Board$i\" value = \"$Word\" $Sub>Subscribe ";
      $Word = "$Keyword"."--SUB--NO";
      print "<input type=radio name=\"Board$i\" value = \"$Word\" $Nosub>Unsubscribe</p><p>";


    }
    print "<br>";
    print "<input type=hidden name = Totalsubs value = $rows>";
  }
  print"<input type=submit value=submit>";
  print"</FORM>";
  print "</td></tr></table>";

# ----------------
# send the footer
  $sth -> finish;
  w3t::send_footer();
