#!/usr/bin/perl
###########################################################################
#    WWWThreads  - Interactive Discussion Forum
#    Rick Baker scream@screamingweb.com 
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
###########################################################################
  use w3tvars qw(%config);
  use w3t qw($dbh);

  use strict;


# -----------------------
# Connect to the database
  w3t::db_connect();


# ----------------------
# Grab their preferences
  my %cookie   = w3t::get_cookie();
  my $Username = $cookie{'Username'};
  my $Password = $cookie{'Password'};
  my %user     = w3t::authenticate($Username,$Password);

  my $TextCols = $user{'TextCols'};
  my $TextRows = $user{'TextRows'};
  $TextCols ||= "80";
  $TextRows ||= "5";


# -------------------
# Get the form input
  my %FORM = w3t::get_input();


# --------------------
# Assign the variables
  my $Username = $user{'Username'};
  my $Password = $user{'Password'};
  my $Number   = $FORM{'Number'};
  my $Subject  = $FORM{'Subject'};
  my $Recip    = $FORM{'Sender'};
  my $Option   = $FORM{'option'};
  my $sth;

# --------------------------------------------------------
# If they selected delete this messages, execute that sub
  if($Option eq "Delete this message"){

    &delete_mess($Username,$Password,$Number,$Subject,$Recip);

  }


# --------------------------------------------------------
# If they selected reply to this message, execute that sub
  if($Option eq "Reply to this message"){

    &reply_mess($Username,$Password,$Number,$Subject,$Recip,$TextCols,$TextRows);
    w3t::exit();

  }


# ----------------------------------------------------------
# If they selected to return to start page, execute that sub
  if($Option eq "Return to your start page"){

    w3t::start_page("$Username","$Password","","");
    w3t::exit();

  }



######################################################################
# delete_mess - Delete this message
######################################################################

  sub delete_mess{

    my ($Username,$Password,$Number,$Subject,$Recip) = @_;


  # ------------------
  # Delete the Message
    my $Username_q = $dbh -> quote($Username);
    my $query = qq!
      DELETE FROM Messages
      WHERE Username = $Username_q
      AND Number = $Number
    !;
    $dbh -> do ($query) or die "Can't execute query: $query. Reason: $DBI::errstr";


  # -------------------------------
  # Return them to their start page
    w3t::start_page($Username,$Password,"","");

  }


####################################################################
# reply_mess - Reply to this message
####################################################################

  sub reply_mess{

    my ($Username,$Password,$Number,$Subject,$Recip,$TextCols,$TextRows) = @_;

  # -------------------------------------
  # Give them a form to reply to a message
    w3t::send_header("Reply to $Recip");

    w3t::table_header("Reply to $Recip");

    if ($Subject !~/Re:/){
      $Subject = "Re: $Subject";
    }
    print qq~ 
    <form method = POST action = "$config{'cgiurl'}/mess_reply.pl">
    <input type=hidden name = Username value = "$Recip">
    <input type=hidden name = Number value = "$Number">
    <input type=hidden name = Sender value = "$Username">
    Subject<br>
    <input type=text name = Subject value = "$Subject" maxlength=55>
    <p> 
    <textarea name = Message cols=$TextCols rows=$TextRows wrap=soft></textarea>
    <p> 
    <input type = submit value=submit>
    </form>
    ~;


  # --------------------------------
  # Show them what it is in reply to
    w3t::table_header("Original Message");

    my $query = qq!
      SELECT Message
      FROM Messages
      WHERE Number = $Number
    !;

    $sth = $dbh -> prepare($query) or die "Query syntax error. $query. $DBI::errstr.";
    $sth -> execute() or die "Can't execute query. $query. Reason: $DBI::errstr";
    my ($Message) = $sth -> fetchrow_array;

    print $Message;

  # ---------------
  # Send the footer
    w3t::send_footer();

  }
