#!/usr/bin/perl
###########################################################################
#    WWWThreads  - Interactive Discussion Forum
#    Rick Baker scream@screamingweb.com 
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
###########################################################################
  use w3tvars qw(%config);
  use w3t qw($dbh);
  use strict;


# -----------------------
# Connect to the database 
  w3t::db_connect();
  my %cookie = w3t::get_cookie();
  my $Username = $cookie{'Username'};
  my $Password = $cookie{'Password'};
  my %user = w3t::authenticate($Username,$Password);


# ------------------
# Check for any bans
  w3t::check_ban($user{'Username'});

                                                
# --------------
# Get the input
  my %FORM = w3t::get_input();


# --------------------
# Assign the variables
  my $Username = $user{'Username'};
  my $Password = $user{'Password'};
  my $Board    = $FORM{'Board'};
  my $what     = $FORM{'what'};
  my $page     = $FORM{'page'};
  my $view     = $FORM{'view'};
  my $sb       = $FORM{'sb'};
  my $sth;

  my $Board_q = $dbh -> quote($Board);

# -----------------------
# Grab the security level
  my $user_security = $user{'Security'};
  $user_security  ||= $config{'anon_security'};

# -----------------------
# Lets grab the User info
  my $Email = $user{'EReplies'};
  my $Eselected;

  if ($Email eq "On"){
    $Eselected = "checked";
  }

  my $TextCols = $user{'TextCols'};
  my $TextRows = $user{'TextRows'};
  $TextCols ||= "80";
  $TextRows ||= "5";



# ------------------
# Get the board info
  my $query =qq!
    SELECT HTML,Anonymous,Locked,Markup,Security
    FROM Boards
    WHERE Keyword = $Board_q
  !;
  $sth = $dbh -> prepare($query) or die "Query syntax error: $DBI::errstr. Query: $query";
  $sth -> execute() or die "Can't execute query: $query. Reason: $DBI::errstr";


# ---------------------------
# Assign the retreived values
  my ($HTML,$Anonymous,$Locked,$Markup,$Security) = $sth -> fetchrow_array;


# -----------------------------------------------------------------
# If there are no anonymous postings, make sure they have logged in
  if ( ($Anonymous eq "Off") && (!$user{'Username'}) ) {
    $sth -> finish;
    w3t::not_right("Anonymous postings are not allowed on this forum.  You need to have a Username and be logged in before posting on this board.");

  }

# ----------------------------------------------------------
# Find out if they are supposed to be making a new post here
  if ($Security > $user_security) {
    w3t::not_right("You do not have a high enough Security level to be making posts on this forum.");
  }

# -----------------
# Give them a page 
  w3t::send_header("Make a New Post","bypass",$Username,$Password);
  w3t::table_header("Make a New Post");
  print "<table cellspacing=0 border=0 width=100% bgcolor=$config{'tddark'}>";
  print "<tr><td>";
  print "Fill out the form below to post a message on the board.";


# -------------------------------
# HTML is disabled, let them know
  if($HTML eq "Off"){
    print " HTML is disabled for this board so you may not use it in your posts.";
  }
  else {
    print " HTML is enabled so you may use it in your posts.";
  }


# --------------------------------------------
# Markup is disabled, so we better let them know
  if($Markup eq "Off"){
    print " Markup is disabled for this board so you may not use markup in your posts.";


# ---------------------------------
# HTML is enabled, so let them know
  } 
  else {
    print " Markup is enabled so you may use <a href=\"$config{'cgiurl'}/faq.pl#html\">Markup on in your posts</a>.";
  }


# --------------------------------------  
# Anonymous is enabled, so let them know
  my $Anon = '';
  if($Anonymous eq "On"){
    print" Anonymous postings are allowed, so if you do not have a Username just put Anonymous in the Username field and leave the password blank.  If you post as Anonymous you will not be able to have replies Emailed to you.";
    $Anon = "Anonymous";
  } 


# ----------------------------------------
# Anonymous is disabled, so let them know
  else {
    print" Anonymous postings are not allowed, so you will need to register a Username before you can post.";
  }
  

# ------------------------------------ 
# The board is locked, so let them know
  if($Locked ne "Open"){
    print" This board is read only, so you must be an administrator to post on it.";
  }

  print qq~
  </td></tr><tr><td bgcolor=$config{'tdlight'}>
  ~;

# -----------------------------------------------------
# Let's find out if they get the default preview or not.
  my $Preview = $user{'Preview'};
  $Preview  ||= $config{'Preview'};

# -----------------------------------------------------------------------
# If we are allowing file attachments and we are dealing with a Mozilla 4+
# Browser then we need a multipart/form-data form
  my $check = w3t::browser_check();

  if( ($Preview eq "off") && ($check eq "true") && ($config{'files'}) ) {
    print "<form method=POST enctype='multipart/form-data' action=\"$config{'cgiurl'}/addpost.pl\">";
  }
  elsif ($Preview eq "off") {
    print "<form method=POST action =\"$config{'cgiurl'}/addpost.pl\">";
  }
  else {
    print "<form method=POST action =\"$config{'cgiurl'}/previewpost.pl\">";
  }  
  print qq~
  <input type=hidden name=Board value="$Board">
  <input type=hidden name=what value="$what">
  <input type=hidden name=page value="$page">
  <input type=hidden name=view value="$view">
  <input type=hidden name=sb value="$sb">
  ~;
  if ($Username) {
    print "<p>Username<br><b>$Username</b><p>";
  }
  else {
    print qq~
    
    Username (between 3 and 16 characters)<br>
    <input type=text name = Username value="$Anon">
    <p>
    Password (between 4 and 10 characters)<br>
    <input type=password name = Password value="">
    <p>
    ~;
  }
  print qq~
  Subject<br>
  <input type=text name = Subject>
  <p>
  Post<br>
  <textarea cols=$TextCols rows=$TextRows wrap=soft name="Body"></textarea>
  <p> 
  <input type=checkbox name=mail value=1 $Eselected> 
  E-mail all replies to my real email address
  </p><p>
  ~;
  
# ------------------------------------------------------------------------
# If we are allowing file attachments and we are dealing with a Mozilla 4+
# browser then we will allow file attachments
  my $check = w3t::browser_check();

  if( ($check eq "true") && ($config{'files'}) && ($Preview eq "on") ) {
    print "File attachments are allowed.  You will be able to attach a file to your post on the next screen.<br>";
  }

  if ( ($check eq "true") && ($config{'files'}) && ($Preview eq "off") ) {

    if ($Username) {
      print "<br>You may attach a file to your post if you want.  File size is limited to $config{'filesize'} bytes<br>";
      print "<input type=file name=attach accept=\"*\">";
    }
    else {
      print "<br>Although File attachments are allowed, you cannot post files as the Anonymous user.";
    }

  }
  elsif ( ($check ne "true") && ($config{'files'}) && ($Preview eq "off") ) {
    print "<br>Although File attachments are allowed, you must be using a Mozilla 4+ compatible browser for this feature.";
  }  


  if ($Preview eq "off") {
    print "<br><br><input type=submit value = \"Add Post\">";
  }
  else {
    print "<input type=submit value = \"Preview Post\">";
  }
  print qq~
  <input type=reset value = "Clear Form">
  </form>
  </td></tr></table>
  ~;

# -------------
# Send a footer
  $sth -> finish;
  w3t::send_footer;
