#!/usr/bin/perl
###########################################################################
#    WWWThreads  - Interactive Discussion Forum
#    Rick Baker scream@screamingweb.com 
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
###########################################################################
  use w3tvars qw(%config);
  use w3t qw($dbh);
  use strict;


# -------------------  
# Get the form input
  my %FORM = w3t::get_input;

# -------------------
# Assign the variables
  my $Subject   = $FORM{'Subject'};
  my $Body      = $FORM{'Body'};
  my $Board     = $FORM{'Board'};
  my $Main      = $FORM{'Main'};
  my $Parent    = $FORM{'Parent'};
  my $what      = $FORM{'what'};
  my $page      = $FORM{'page'};
  my $view      = $FORM{'view'};
  my $oldnumber = $FORM{'oldnumber'};
  my $mode      = $FORM{'mode'};
  my $sb        = $FORM{'sb'};
  my $mail      = $FORM{'mail'};
  my $sth;


# ------------------
# Grab the IP address
  my $IP = $ENV{'REMOTE_ADDR'};


# -----------------------------------
# Make sure all fields are filled in
  if(!$Subject or !$Body) {
    w3t::not_right("All required fields are not filled in.");
  }


# -------------------------------------------------------
# Make sure the Username is either Anonymous or is valid.
  w3t::db_connect();
  my %user;
  if ($FORM{'Username'} ne 'Anonymous') {
    my $Username;
    my $Password;
    if ($FORM{'Username'} and $FORM{'Password'}) {
      my $Username_q = $dbh ->quote($FORM{'Username'});
      my $query = qq!
        SELECT Username,Password
        FROM Users
        WHERE Username = $Username_q
      !;
      my $sth = $dbh -> prepare($query) or die "Can't prepare $query.  Reason: $DBI::errstr.";
      $sth -> execute() or die "Can't execute $query.  Reason: $DBI::errstr.";
      if (!$sth -> rows) {
        w3t::not_right("We could not find the Username/Password in our database.");
      }
     ($Username,$Password) = $sth -> fetchrow_array;
     if ( ($FORM{'Password'} ne $Password) && (crypt($FORM{'Password'},$Password) ne $Password) ) { 
        w3t::not_right("We could not find the Username/Password in our database.");
      }
      %user = w3t::authenticate($Username,$Password); 
    }
    else {
      %user = w3t::authenticate();
    }
  }
  if (($FORM{'Username'} ne 'Anonymous') and (!( defined $user{'Username'}) ) ) {
    w3t::not_right("We could not find the Username/Password in our database.");
  }
  my ($Username, $Password);
  $user{'Username'} ? ($Username = $user{'Username'}) : ($Username = $FORM{'Username'});
  $user{'Password'} ? ($Password = $user{'Password'}) : ($Password = $FORM{'Password'});



# --------------------------
# Grab the board information
  my $Board_q = $dbh -> quote($Board);
  my $query = qq!
    SELECT HTML,Anonymous,Locked,Markup
    FROM   Boards
    WHERE  Keyword = $Board_q
  !;
  $sth = $dbh -> prepare ($query) or die "Query syntax error: $DBI::errstr. Query: $query";
  $sth -> execute() or die "Can't execute query: $query. Reason: $DBI::errstr";
  my ($HTML,$Anonymous,$Locked,$Markup) = $sth -> fetchrow_array;


# -----------------------------------------------------------------------
# If Anonymous is off and they are trying to post as anonymous tell them
# it doesn't work
  if (($Anonymous eq "Off") && ($Username eq "Anonymous")) {
    $sth -> finish;
    w3t::not_right("Anonymous posts are not allowed on this board.");
  }


# ---------------------------------------------------------------
# If the board is locked and they are not an admin, let them know
  if(($Locked ne "Open") && ($user{'Status'} ne "Administrator") && ($user{'Status'} ne "Moderator") ) {
    $sth -> finish;
    w3t::not_right("This board is read only.  Only Administrators and Moderators can post here.");
  }


# --------------------------------------
# Lets see if this post is locked or not
  my $PStatus = '';
  if ($Parent) { 
    my $query = qq!
      SELECT Status 
      FROM $Board
      WHERE Number = $Parent 
    !;
    $sth = $dbh -> prepare ($query) or die "Query syntax error: $DBI::errstr. Query: $query";
    $sth -> execute() or die "Can't execute query: $query. Reason: $DBI::errstr";
    ($PStatus) = $sth -> fetchrow_array;

  }

  if ( ($PStatus eq "C") && ($user{'Status'} ne "Administrator") && ($user{'Status'} ne "Moderator") ) {

    $sth -> finish;
    w3t::not_right("I'm sorry, this thread is locked and you don't have the proper permission to add to it.");

  }



# ---------------------------------
# Get rid of < and > in the subject
  $Subject =~s /</&lt;/g;
  $Subject =~s />/&gt;/g;


# -------------------------------------------------------------
# If HTML is off then we need to get rid of < and > in the body
  if ($HTML eq "Off") {

    $Body =~s />/&gt;/g;
    $Body =~s /</&lt;/g;
    $Body =~s /&lt;br&gt;/<br>/g;

  }

# -----------------------------
# Add the signature to the post
  $Body = "$Body<br><br>$user{'Signature'}";


# -------------------------------------------
# If Markup is on the we format the markup code
  if ($Markup eq "On") {

    $Body =~ s/\[b\]/<b>/ig;
    $Body =~ s/\[\/b\]/<\/b>/ig;
    $Body =~ s/\[i\]/<i>/ig;
    $Body =~ s/\[\/i\]/<\/i>/ig;

  # -----------------------
  # Convert the color codes
    $Body =~ s/\[red\]/<font color=red>/ig;
    $Body =~ s/\[\/red\]/<\/font color=red>/ig;
    $Body =~ s/\[green\]/<font color=green>/ig;
    $Body =~ s/\[\/green\]/<\/font color=green>/ig;
    $Body =~ s/\[blue\]/<font color=blue>/ig;
    $Body =~ s/\[\/blue\]/<\/font color=blue>/ig;
    $Body =~ s/\[orange\]/<font color=orange>/ig;
    $Body =~ s/\[\/orange\]/<\/font color=orange>/ig;
    $Body =~ s/\[purple\]/<font color=purple>/ig;
    $Body =~ s/\[\/purple\]/<\/font color=purple>/ig;
    $Body =~ s/\[white\]/<font color=white>/ig;
    $Body =~ s/\[\/white\]/<\/font color=white>/ig;
    $Body =~ s/\[black\]/<font color=black>/ig;
    $Body =~ s/\[\/black\]/<\/font color=black>/ig;
    $Body =~ s/\[yellow\]/<font color=yellow>/ig;
    $Body =~ s/\[\/yellow\]/<\/font color=yellow>/ig;

  # --------------------
  # Convert the smiley's
    $Body =~s,\[smile\],<img src=\"$config{'images'}/smile.gif\">,isg;
    $Body =~s,\[frown\],<img src=\"$config{'images'}/frown.gif\">,isg;
    $Body =~s,\[wink\],<img src=\"$config{'images'}/wink.gif\">,isg;

  # ----------------------------
  # Replace quote markup -> html
    $Body =~ s,\[quote\](.*)\[/quote\],<blockquote><font size=1>In reply to:</font><hr><p>$1<p><hr></blockquote><p>,isg;

  # ---------------------------
  # Convert code markup -> html
    $Body =~ s,\[pre\](.*)\[/pre\],<pre>$1</pre><p>,isg;


  # ---------------------------
  # Convert url markup -> html
    $Body =~ s,\[url\]http://(.*)\[/url\],<A HREF="http://$1">http://$1</A>,isg;
    $Body =~ s,\[url\](.*)\[/url\],<A HREF="http://$1">http://$1</A>,isg;


  # ----------------------------
  # Convert email markup -> html
    $Body =~ s,\[email\](.*)\[/email\],<A HREF="mailto:$1">$1</A>,isg;



  # -------------------------------------------------
  # Convert image markup -> html if allowimages is on
    if ($config{'allowimages'}) {
      $Body =~ s,\[image\](.*)\[/image\],<IMG SRC="$1">,isg;
    }


  # ---------------------------------------------
  # Get rid of the trailing br's on certain codes
    $Body =~s/<\/blockquote><p><br>/<\/blockquote><p>/g;
    $Body =~s/<\/pre><p><br>/<\/pre><p>/g;
    $Body =~s/<pre><br>/<pre>/g;

  }

  
# -----------------------------------
# If not anonymous,Give them a cookie
  if ($Username ne "Anonymous") {
    w3t::set_cookie('Username',"$Username",1,'Password',"$user{'Password'}",1);
  }  
  w3t::send_header("Preview your post");
  w3t::table_header("Preview your post");

  print qq~ 
  <table cellspacing=0 border=0 width=100% bgcolor=$config{'tdlight'}>
  <tr><td>
  The following is a preview of your post.  If everything looks ok then you can click 'Continue' and your post will be entered.  If not then use your back button to go back and edit some more. 
  ~;


# If we are allowing file attachments and we are dealing with a Mozilla 4+
# Browser then we need a multipart/form-data form 
  my $check = w3t::browser_check();

  if( ($check eq "true") && ($config{'files'}) ) {
    print "<form method=POST enctype='multipart/form-data' action=\"$config{'cgiurl'}/addpost.pl\">";
  }
  else {
    print "<form method=POST action =\"$config{'cgiurl'}/addpost.pl\">";
  }
  print qq~
  <input type=hidden name=Board value="$Board">
  <input type=hidden name=Username value="$Username">
  <input type=hidden name=Password value="$Password">
  <input type=hidden name=IP value="$IP">
  <input type=hidden name=what value="$what">
  <input type=hidden name=page value="$page">
  <input type=hidden name=view value="$view">
  <input type=hidden name=oldnumber value="$oldnumber">
  <input type=hidden name=mode value="$mode">
  <input type=hidden name=sb value="$sb">
  <input type=hidden name=mail value="$mail">
  <input type=hidden name=PStatus value="$PStatus">
  ~;


  my $FormSubject = w3t::url_encode($Subject);
  my $FormBody = w3t::url_encode($Body);

  print qq~
  <input type=hidden name=Subject value="$FormSubject">
  <input type=hidden name=Body value="$FormBody">
  <input type=hidden name=Parent value="$Parent">
  <input type=hidden name=Main value="$Main">
  </td></tr><tr><td bgcolor=$config{'tddark'}>
  <p>Subject: $Subject
  <p>
  $Body
  
  ~;


# -------------------------------------------------------------------------
# If we are allowing file attachments and we are dealing with a Mozilla 4+
# browser then we let them attach files.  Also we need to make sure they
# are not posting as Anon.
  $check = w3t::browser_check();

  if( ($check eq "true") && ($config{'files'}) && ($Username ne "Anonymous") ) {
    print "<br><br>You may attach a file to your post if you want.  File size is limited to $config{'filesize'} bytes<br>";
    print "<input type=file name=attach accept=\"*\">";
  } 
  elsif ( ($check eq "true") && ($config{'files'}) && ($Username eq "Anonymous") ) {
    print "<br><br>Although File attachments are allowed, you cannot post files as the Anonymous user.";
  }
  elsif ( ($check ne "true") && ($config{'files'}) ) {
    print "<br><br>Although File attachments are allowed, you must be using a Mozilla 4+ compatible browser for this feature.";
  }


  print qq~
  <br><br>
  <input type=submit value="Continue">
  </td></tr></table>
  ~;

  $sth -> finish;
  w3t::send_footer;
