#!/usr/bin/perl
###########################################################################
#    WWWThreads  - Interactive Discussion Forum
#    Rick Baker scream@screamingweb.com 
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
###########################################################################
  use w3tvars qw(%config);
  use w3t qw($dbh);

  use strict;


# -----------------------
# Connect to the database
  w3t::db_connect();


# ----------------------
# Grab their preferences
  my %cookie   = w3t::get_cookie();
  my $Username = $cookie{'Username'};
  my $Password = $cookie{'Password'};
  my %user     = w3t::authenticate($Username,$Password);

  my $TextCols = $user{'TextCols'};
  my $TextRows = $user{'TextRows'};
  $TextCols ||= "80";
  $TextRows ||= "5";


# --------------------
# Assign the variables
  my $From = $user{'Username'};


# ------------------
# Check for any bans
  w3t::check_ban($From);

                                                

# ---------------------------------------------------------------
# Give them a form to fill out so they can send a private message
  w3t::send_header("Send a private message");
  w3t::table_header("Send a private message");

  print qq~

  If you know the Username of a registered user you can send a private message by filling out the information below.
  </p>
  <form method=POST action ="$config{'cgiurl'}/sendmess.pl">
  <input type=hidden name=Sender value="$From">
  <p>Username<br>
  <input type = text name = Username>
  <p>
  Subject<br>
  <input type = text name = Subject maxlength = 55>
  <p>
  <textarea name=Message cols=$TextCols rows=$TextRows wrap=soft></textarea>
  <p>
  <input type=submit value=submit>
  <input type=reset value=reset>
  </form>

  ~;


# -------------
# Send a footer
  w3t::send_footer();

