#!/usr/bin/perl
###########################################################################
#    WWWThreads  - Interactive Discussion Forum
#    Rick Baker scream@screamingweb.com 
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
###########################################################################
  use w3tvars qw(%config);
  use w3t qw($dbh);

  use strict;


# ------------------------
# Connect to the database
  w3t::db_connect();


# ----------------
# Grab their prefs
  my %cookie   = w3t::get_cookie();
  my $Username = $cookie{'Username'};
  my $Password = $cookie{'Password'}; 
  my %user     = w3t::authenticate($Username,$Password);


# -------------
# Get the input
  my %FORM = w3t::get_input();


# --------------------------------------------------------------------
# If they haven't logged in yet then they cant send a message 
  if (!$user{'Username'}) {

    w3t::not_right("You have not logged in yet.  Before you can send a private message to another user you have to login.");

  }


# ----------------------
# Grab their preferences
  my $TextCols = $user{'TextCols'};
  my $TextRows = $user{'TextRows'};
  $TextCols ||= "80";
  $TextRows ||= "5";


# --------------------
# Authenticate the user
  w3t::db_connect();

  %user = w3t::authenticate();
  if (!( defined $user{'Username'}) ) {

    w3t::not_right ("We could not authenticate your Username/Passord.");

  }


# ------------------
# Check for any bans
  w3t::check_ban($user{'Username'});

                                                
# --------------------
# Assign the variables
  my $User  = $FORM{'User'};
  my $From  = $user{'Username'};
  my $Board = $FORM{'Board'};
  my $what  = $FORM{'what'};
  my $page  = $FORM{'page'};
  my $view  = $FORM{'view'};
  my $mode  = $FORM{'mode'};
  my $sb    = $FORM{'sb'};
  my $User  = w3t::url_decode($User);


# --------------------------------------------------------------
# Give them a form to fill out so they can send a private message
  w3t::send_header("Send a private message to $User");
  w3t::table_header("Send a private message to $User");

  print qq~ 

  Fill in the following info to send a private message to $User.  They will get this message the next time they Login.
  </p>
  <form method=POST action ="$config{'cgiurl'}/sendmessage.pl">
  <input type=hidden name=Sender value="$From">
  <input type=hidden name=Board value="$Board">
  <input type=hidden name=what value="$what">
  <input type=hidden name=page value="$page">
  <input type=hidden name=view value="$view">
  <input type=hidden name=mode value="$mode">
  <input type=hidden name=sb value="$sb">
  <p>Username<br>
  <input type = text name = Username value=$User>
  <p>
  Subject<br>
  <input type = text name = Subject maxlength = 55>
  <p>
  <textarea name=Message cols=$TextCols rows=$TextRows wrap=soft></textarea>
  <p>
  <input type=submit value=submit>
  <input type=reset value=reset>
  </form>

  ~;


# ----------------
# Send a footer
  w3t::send_footer();

