#!/usr/bin/perl
###########################################################################
#    WWWThreads  - Interactive Discussion Forum
#    Rick Baker scream@screamingweb.com 
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
###########################################################################
  use w3tvars qw(%config);
  use w3t qw($dbh);

  use strict;


# ------------------
# Get the form input
  my %FORM = w3t::get_input();


# --------------------
# Assign the variables
  my $Username = $FORM{'User'};
  my $Number   = $FORM{'Number'};
  my $From     = $FORM{'Board'};
  my $what     = $FORM{'what'};
  my $page     = $FORM{'page'};
  my $view     = $FORM{'view'};
  my $mode     = $FORM{'mode'};
  my $sb       = $FORM{'sb'};
  my $search   = $FORM{'search'};
  my $sth;


# -----------------------
# Connect to the database
  w3t::db_connect();


# ---------------------
# Unencode the Username
  $Username = w3t::url_decode($Username);


# ------------------------
# Now show them their page 
  w3t::send_header("Profile for $Username");
  w3t::table_header("Profile for $Username");


# ------------------------------
# Grab the profile for this user
  my $Username_q = $dbh -> quote($Username);
  
  my $query = qq!
    SELECT Fakeemail,Name,Totalposts,Homepage,Occupation,Hobbies,Location,Bio,Extra1,Registered
    FROM   Users
    WHERE  Username = $Username_q
  !;

  $sth = $dbh -> prepare($query) or die "Query syntax error: $DBI::errstr. QUery: $query";
  $sth -> execute() or die "Can't execute query: $query. Reason: $DBI::errstr";


# ----------------------------
# Let's see if we found a user
  my $rows = $sth -> rows;


# ----------------
# Assign the stuff
  my ($Fakeemail,$Name,$Totalposts,$Homepage,$Occupation,$Hobbies,$Location,$Bio,$ICQ,$Registered) = $sth -> fetchrow_array;


# -----------------------------
# Show the profile if it exists
  if ($rows > 0) {

    print qq~ 

    <TABLE border=0 width=100% bgcolor=$config{'tdlight'} cellspacing=0>
    <tr><td width=20%>
    Email
    </td><td>
    &nbsp;<a href="mailto:$Fakeemail">$Fakeemail</a>
    </td></tr><tr><td>
    Name
    </td><td>
    &nbsp;$Name
    </td></tr><tr><td>
    Total Posts
    </td><td>
    &nbsp;$Totalposts
    </td></tr><tr><td valign=top>
    Homepage
    </td><td>
    ~;
    if ($Homepage) {
      print "&nbsp;<a href=\"http://$Homepage\">http://$Homepage</a>";
    }
    else {
      print "&nbsp;";
    }
    print qq~
    </td></tr><tr><td valign=top>
    Occupation
    </td><td>
    &nbsp;$Occupation
    </td></tr><tr><td valign=top>
    Hobbies
    </td><td>
    &nbsp;$Hobbies
    </td></tr><tr><td valign=top>
    Location
    </td><td>
    &nbsp;$Location
    </td></tr><tr><td valign=top>
    Bio
    </td><td>
    &nbsp;$Bio
    </td></tr><tr><td valign=top>
    ICQ Number
    </td><td>
    &nbsp;$ICQ
  ~;
  if ( ($ICQ) && ($config{'ICQ_Status'} = "on") ){
    print "<img src=\"http://online.mirabilis.com/scripts/online.dll?icq=$ICQ&img=1\">";
  }
  my $date = w3t::convert_time($Registered);
  print "</td></tr><tr><td valign=top>";
  print "Registered on";
  print "</td><td>";
  print "&nbsp;$date";
  print"  </td></tr></table>";
  if ($config{'private'}) {
    my $encoded = w3t::url_encode($Username);
    print qq~
    <a href="$config{'cgiurl'}/sendprivate.pl?User=$encoded&Board=$From&what=$what&page=$page&view=$view&mode=$mode&sb=$sb">
    <img src="$config{'images'}/sendprivate.gif" alt="Send Private Message" border=0></a>
    </a>
    ~;
  }

  } else {

    print"<TABLE border=0 width=100% bgcolor=$config{'tdlight'} cellspacing=0>";
    print"<tr><td>";
    print "This user is no longer in our database.<br><br>";

  }


# -------------------------------------------------------------------
# If we came from showpost.pl then give them a link back to that post
  if ($what eq "showpost") {

    print "<a href=\"$config{'cgiurl'}/showpost.pl?Board=$From&Number=$Number&page=$page&view=$view&mode=$mode&sb=$sb\"><img src=\"$config{'images'}/returntoforum.gif\" alt=\"Return to the Forum\" border=0></a>";


# ----------------------------------------------------------------
# If they are coming from the search page then we go back to there.
  } 
  elsif ($what eq "search") {

    my $Words      = $FORM{'Words'};
    my $Forum      = $FORM{'Forum'};
    my $Match      = $FORM{'Match'};
    my $Searchpage = $FORM{'Searchpage'};
    my $Limit      = $FORM{'Limit'};
    my $Old        = $FORM{'Old'};
    my $Words      = w3t::url_encode($Words);
    my $Forum      = w3t::url_encode($Forum);
    my $Match      = w3t::url_encode($Match);
    print "<a href=\"$config{'cgiurl'}/dosearch.pl?Forum=$Forum&Words=$Words&Match=$Match&Searchpage=$Searchpage&Limit=$Limit&Old=$Old\"><img src=\"$config{'images'}/returntoforum.gif\" alt = \"Return to the Forum\" border=0></a>";


# -----------------------------------------------------------------
# If they are coming from a private message then we return to there
  }
  elsif ($what eq "viewmessage") {
  
    my $ViewMessage = $FORM{'Message'};
    print "<a href=\"$config{'cgiurl'}/viewmessage.pl?message=$ViewMessage\"><img src=\"$config{'images'}/returntoforum.gif\" alt = \"Return to the Forum\" border = 0></a>";


# -----------------------------------------
# Otherwise they came from their login page
  }
  elsif ($what eq "login") {

    print "<a href=\"$config{'cgiurl'}/login.pl\"><img src=\"$config{'images'}/returntoforum.gif\" alt = \"Return to the Forum\" border = 0></a>";



# --------------------------------------------------------
# If we didn't then give them a link back to all the posts
  } 
  else {

    print "<a href=\"$config{'cgiurl'}/wwwthreads.pl?action=list&Board=$From&page=$page&view=$view&sb=$sb\"><img src=\"$config{'images'}/returntoforum.gif\" alt=\"Return to the Forum\" border=0></a>";

  }


# ---------------
# Send the footer
  $sth -> finish;
  w3t::send_footer();

