#!/usr/bin/perl
###########################################################################
#    WWWThreads  - Interactive Discussion Forum
#    Rick Baker scream@screamingweb.com 
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
###########################################################################
package w3tvars;

require Exporter;
@ISA = qw (Exporter);
@EXPORT = qw(@EXPORT_OK);

@EXPORT_OK = qw(%config);

use vars qw(%config);
use strict;


###########################################################################
# User defined variables
###########################################################################

  # ---------- THESE VALUES MUST BE CHANGED FOR YOUR PARTICULAR NEEDS
  # ---------- FOR THE PROGRAM TO FUNCTION PROPERLY.

  # Url to the cgi-bin containing the WWWThreads package
    $config{'cgiurl'}   = 	"http://www.wwwthreads.org/perl";

  # Relative Url containing images 
    $config{'images'}   = 	"/images";

  # Path containing the .include files
    $config{'includes'} = 	"/home/httpd/perl/includes";

  # Name of the server running sql - (yourhost.com or localhost)
    $config{'dbserver'} = 	"localhost";

  # Name of the database you created for the sql tables
    $config{'dbname'}   = 	"WWWThreads";

  # Name of the DBI driver you are using
    $config{'dbdriver'} = 	"mysql";

  # Name of the database user to connect as.
    $config{'dbuser'}   = 	'nobody';

  # Password of the database user.
    $config{'dbpass'}   = 	'';

  # Use sendmail or a SMTP server.  If you are on a server that has
  # the sendmail program then set $config{'sendmail'} to the location
  # of the server.  If you do not have sendmail then set 
  # config{'SMTP'} to the name of the SMTP server you wish to use.
  # Make sure you uncomment the one you want to use.
  # DO NOT LEAVE BOTH UNCOMMENTED
    $config{'sendmail'} = 	"/usr/sbin/sendmail";
  # $config{'SMTP'} = 		"name.smtp.server.";

  # URL of the server the program is running from
    $config{'referer'}  = 	"http://www.wwwthreads.org";

  
  # ------THESE VALUES WILL CHANGE THE BEHAVIOUR, LOOK AND FEEL OF
  # ------WWWTHREADS BUT DO NOT HAVE TO BE CHANGED

  # -----COLOR SCHEME / DESIGN

  # 1 = Use a background image : 0 = don't use background image
    $config{'useimage'} = 	0;                
                                      
  # If useimage=1, name of image to be used 
    $config{'backimage'} = 	"back.gif";      
                          
  # Color of webpage backgrounds                 
    $config{'bodybg'} = 	"#000000";	

  # Table Header colors
    $config{'tableheader'} = 	"333355";

  # Category color background
    $config{'catcolor'} = 	"111133";

  # Dark table colors
    $config{'tddark'} = 	"#444466";

  # Light table colors
    $config{'tdlight'} = 	"#333355";

  # Alternate table colors
    $config{'tdalt'} = 		"#000000";

  # Text color
    $config{'textcol'} = 	"d0d0d0";

  # Link color
    $config{'linkcol'} = 	"ffc000";

  # Hover link color (IE only)
    $config{'hovercol'} = 	"ffffff";

  # Visited link color
    $config{'linkvis'} = 	"ffc000";

  # Active link color
    $config{'linkactive'} =	"red";

  # Underline links - no = No underline : yes = underline
    $config{'underline'} = 	"no";

  # Link weight - bold or normal
    $config{'linkweight'} =	"bold";

  # Base font size
    $config{'fontsize'} =	"10";

  # Base font face
    $config{'fontface'} = 	"helvetica,arial";

  # Header font size
    $config{'headerfont'} = 	"16";

  # Header font face
    $config{'headerfontface'} = "helvetica,arial";
 
  # Header font color
    $config{'headerfontcolor'}=	"ffc000";
 
  # Font color to use when showing the number of new posts on the main page
    $config{'newfontcolor'} = 	"ffc000";
 
  # Menu position - 
  # side = Menu on the left side
  # top  = Menu on top
    $config{'menu'} = 		"top";

  # Post format
  # top - Post headers above each post
  # side - Post headers are on the left of each post
    $config{'post_format'} = 	 "top";

  # Default listing to flat or threaded.  
  # If you set this to "flat" then when you view a board, a list of all 
  # parent posts will be shown, and when you click on a post to read, all 
  # replies to this post will be listed on one page.
  # If you set this to "threaded" then when you view a board a thread list
  # of all parent posts and replies will be shown.
    $config{'postlist'} = 	"threaded";

  # Default threaded lists to collapsed or expanded
  # If your $postlist = "threaded" then you can set this variable to either
  # "collapsed" or "expanded".
  # If you set it to "collapsed" then only the parent posts will be shown
  # and you will have to click on the message to view the replies.
  # If you set it to "expanded" then parent posts and replies will be shown
  # on the main page.
    $config{'threaded'} = 	"collapsed";

  # Default sort order
  # 1 - Descending Subject
  # 2 - Ascending Subject
  # 3 - Descdending Poster
  # 4 - Ascending Poster
  # 5 - Descending Date
  # 6 - Ascending Date
    $config{'sort'} = 		5;

  # Default number of posts per page - This only counts parent posts
    $config{'postsperpage'} = 	"10";
   
  # Dateslip - If this is "on" when replies are made to a thread, this thread
  # will be moved up to the top of the post list when sorting by descending
  # date.  If this is "off" threads will stay in their original position
    $config{'dateslip'} =	"on";


  # -----SITE SPECIFIC / NAVIGATION

  # Title of site
    $config{'title'} = 		"WWWThreads Demo / Support";

  # Your home page
    $config{'homeurl'} = 	"http://www.wwwthreads.org";

  # Text for your homepage link
    $config{'urltitle'} = 	"WWWThreads.org";

  # Your email address
    $config{'emailaddy'} = 	"scream\@wwwthreads.org";

  # Text for your email address
    $config{'emailtitle'} = 	"Contact Me";


  # ------SPECIAL FUNCTIONS

  # Default board security level
  # Each user and board has a security level.  Users with lower security
  # levels than a board, will not be able to see that board
    $config{'board_security'} = 50;

  # Default user security level
  # All new users will be set with this user level.
    $config{'user_security'} = 50; 

  # The Anon security level
  # Users who have not logged in will have this security level
    $config{'anon_security'} = 50;

  # Max length of signatures
    $config{'Sig_length'} = 	"100";

  # When persistent cookies will expire
    $config{'cexp'} = 		'Thu, 31-Dec-2020 23:00:00 GMT';

  # If your time needs to be adjusted, in hours (2,1,0,-1,-2)
    $config{'adjusttime'} = 	0;

  # Show the ip address of the posters
    $config{'showip'} = 	1;

  # Allow subscriptions to boards.  If you allow this then you have to
  # have subscription.pl in the cron directory setup to run nightly.
    $config{'subscriptions'} = 	1;

  # Allow private messages.  User's will still receive the welcome message
  # and private messages will still be used for admin purposes, but general
  # users will not be able to send private messages
    $config{'private'} = 	1;

  # Allow the [image] markup tag.  This is a global option for now.  At a
  # later date this will be configurable by board.
  # 1 = allow them; 0 = do not allow
    $config{'allowimages'} = 	1;

  # Allow File Attachments.  If you provide a path to a directory below
  # then File Attachments will be allowed.  If you leave it blank, then they
  # will not.  Make sure this directory is writeable by everyone
    $config{'files'} = 		"/home/httpd/html/wwwthreads/files";

  # We also need the url to the files directory.
    $config{'fileurl'} = 	"http://www.wwwthreads.org/files";

  # If you are allowing file attachments then you need to set a maximum
  # filesize.  If a user tries to upload a file larger than what is set
  # they will get an error message.  This is measured in bytes.
    $config{'filesize'} = 	100000;

  # Which time format to use.  
  # long  = "Sun Mar 7 10:19:48 1999";
  # short = "3/7/99 10:19 AM";
    $config{'timeformat'} = 	"short";

  # Your Time Zone - PST, EST, etc.
    $config{'timezone'} =	"PST";

  # List info on main board page.  If you turn this on, The moderator,
  # Markup status and Anonymous posting status will be listed on the main
  # page as well as on the individual boards.
    $config{'maininfo'} = 	"off";

  # Allow multiple usernames from the same email address
  # On - "Allow multiple" : Off - "Do not allow multiple"
    $config{'multiuser'} = 	"off";

  # Default to having a preview post screen
    $config{'Preview'} =	"on";

  # These are the extra fields for users to fill out in their profiles.
  # If you leave these blank they will not be used.  If you give them a
  # title then they will be.
    $config{'extra1'} = 	"ICQ";
    $config{'extra2'} = 	"";
    $config{'extra3'} = 	"";
    $config{'extra4'} = 	"";
    $config{'extra5'} = 	"";

  # Use the ICQ status indicator.  Depending on the size of your user database
  # you might be required to turn this off.  Please read the ICQ license
  # agreement at http://www.icq.com/legal/indicator.html
    $config{'ICQ_Status'} = 	"off";

1;
